#define BIRD_STRENGTH 30

// internal strength not used with birdy
// three animation lists
struct Line3d birdy1[] =
{
   {0  , 0, _0_1_0},
   {255, 0, _1_1_0},
   {255, 0, _1_0_0},
   {255, 0, _1_N_0},

   {255, 0, _1_1_0},
   {255, 0, _1_0_0},
   {255, 0, _1_N_0},

   {255, 0, _0_0_1},

   {255, 0, _N_1_0},
   {255, 0, _N_0_0},
   {255, 0, _N_N_0},

   {255, 0, _N_1_0},
   {255, 0, _N_0_0},
   {255, 0, _N_N_0},

   {255, 0, _0_0_N},

   {  1, 0, _0_0_1}
};

struct Line3d birdy2[] =
{
   {255, 0, _1_0_0},
   {255, 0, _1_0_0},
   {255, 0, _1_N_0},

   {255, 0, _1_1_0},
   {255, 0, _1_0_0},
   {255, 0, _1_0_0},

   {255, 0, _0_0_1},

   {255, 0, _N_0_0},
   {255, 0, _N_0_0},
   {255, 0, _N_N_0},

   {255, 0, _N_1_0},
   {255, 0, _N_0_0},
   {255, 0, _N_0_0},

   {255, 0, _0_0_N},

   {  1, 0, _0_0_1}
};

struct Line3d birdy3[] =
{
   {0  , 0, _0_N_0},
   {255, 0, _1_N_0},
   {255, 0, _1_0_0},
   {255, 0, _1_N_0},

   {255, 0, _1_1_0},
   {255, 0, _1_0_0},
   {255, 0, _1_1_0},

   {255, 0, _0_0_1},

   {255, 0, _N_N_0},
   {255, 0, _N_0_0},
   {255, 0, _N_N_0},

   {255, 0, _N_1_0},
   {255, 0, _N_0_0},
   {255, 0, _N_1_0},

   {255, 0, _0_0_N},

   {  1, 0, _0_0_1}
};

// makes one animation structure...
struct Line3d *birdy[] =
{
  birdy1,
  birdy2,
  birdy3,
  birdy2
};

init3dBird()
{
 cosx = cosinus3d[angle_x];
 sinx = sinus3d[angle_x];
 cosy = cosinus3d[angle_y];
 siny = sinus3d[angle_y];
 cosz = cosinus3d[angle_z];
 sinz = sinus3d[angle_z];

 // per single vector about 250 - 300 cycles
 //...  all used vector combinations
 // set to init for birdy
 INIT_0_1_0_A;
 INIT_1_N_0_A;
 INIT_1_0_0_A;
 INIT_1_1_0_A;
 INIT_0_0_1_A;
}

void bird_demo()
{
  unsigned short animCounter;
  unsigned short animSecCounter;
  animCounter = 0;
  animSecCounter = 0;

  angle_x = 9;
  angle_y = 2;
  angle_z = 8;
  ym_init(&BLAST1_data);

  while (true)
  {
    start_one_vectrex_round();  /* start vectrex round */
    intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

    init3dBird();
    zero_beam();
    move_to(0, 0);
    set_scale(BIRD_STRENGTH);
    draw_3d(birdy[animCounter]);

    if (joystick1_button4)
    {
      angle_x++;
      if (angle_x == 64) angle_x = 0;
    }
    if (joystick1_button3)
    {
      angle_y++;
      if (angle_y == 64) angle_y = 0;
    }
    if (joystick1_button2)
    {
      angle_z++;
      if (angle_z == 64) angle_z = 0;
    }
    animSecCounter++;
    if (animSecCounter == 10) // change animation only every 10 frame
    {
     animSecCounter = 0;
     animCounter++;
     if (animCounter == 4)
     {
      animCounter = 0;
     }
    }
    if (joystick1_button1)
    {
      break;
    }
    read_buttons();
  }
}

struct BirdAngles
{
 signed short px;
 signed short py;
 unsigned short x;
 unsigned short y;
 unsigned short z;
};

#define BIRD_COUNT 5
struct BirdAngles birds[BIRD_COUNT];
unsigned short activeBird;
unsigned short animCounter;
unsigned short animSecCounter;
unsigned short i;
unsigned short buttonState;
void birds_demo()
{
  animCounter = 0;
  animSecCounter = 0;
  activeBird = 0;
  buttonState = 0;

  // we could loop and randomize here
  // than we would be independent of bird count
  // ... but what the heck, its a demo...
  birds[0].px = 50;
  birds[0].py = 50;
  birds[0].x = 9;
  birds[0].y = 2;
  birds[0].z = 8;

  birds[1].px = -50;
  birds[1].py = -50;
  birds[1].x = 12;
  birds[1].y = 5;
  birds[1].z = 8;

  birds[2].px = 50;
  birds[2].py = -50;
  birds[2].x = 2;
  birds[2].y = 7;
  birds[2].z = 2;

  birds[3].px = -50;
  birds[3].py = 50;
  birds[3].x = 15;
  birds[3].y = 1;
  birds[3].z = 7;

  birds[4].px = 0;
  birds[4].py = 0;
  birds[4].x = 5;
  birds[4].y = 11;
  birds[4].z = 2;

  ym_init(&BLAST1_data);

  while (true)
  {
    if (ym_cdata == 0) // reinint music if done
    {
     ym_init(&BLAST1_data);
    }
    start_one_vectrex_round();  /* start vectrex round */

    for (i = 0; i<BIRD_COUNT; i++)
    {
     angle_x = birds[i].x;
     angle_y = birds[i].y;
     angle_z = birds[i].z;
     init3dBird();
     zero_beam();
     set_scale(200);
     move_to(birds[i].px, birds[i].py);
     set_scale(BIRD_STRENGTH);
     if (activeBird == i)
     {
      intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */
     }
     else
     {
      intensity(MAX_BRIGHTNESS/2);  /* set intensity of vector beam... */
     }
     draw_3d(birdy[animCounter]);
    }

    if (joystick1_button4)
    {
      birds[activeBird].x++;
      if (birds[activeBird].x == 64) birds[activeBird].x = 0;
    }
    if (joystick1_button3)
    {
      birds[activeBird].y++;
      if (birds[activeBird].y == 64) birds[activeBird].y = 0;
    }
    if (joystick1_button2)
    {
      birds[activeBird].z++;
      if (birds[activeBird].z == 64) birds[activeBird].z = 0;
    }
    animSecCounter++;
    if (animSecCounter == 10)
    {
     animSecCounter = 0;
     animCounter++;
     if (animCounter == 4)
     {
      animCounter = 0;
     }
    }
    if (joystick2_button2)
    {
      birds[activeBird].px++;
    }
    if (joystick2_button3)
    {
      birds[activeBird].py++;
    }
    if (joystick2_button1)
    {
      if (buttonState == 0)
      {
       activeBird++;
       if (activeBird == BIRD_COUNT) activeBird=0;
      }
    }
    buttonState = joystick2_button1;
    if (joystick1_button1)
    {
      break;
    }
    read_buttons();
  }
}
