#define ELITE_STRENGTH 240

struct Line3d elite[] =
{
 // first this is an ordinary cube
 {0, ELITE_STRENGTH/2, _N_1_N}, // trial and error !
 {255, ELITE_STRENGTH, _1_0_0},
 {255, ELITE_STRENGTH, _0_1_0},
 {255, ELITE_STRENGTH, _N_0_0},
 {255, ELITE_STRENGTH, _0_N_0},

 {255, ELITE_STRENGTH, _0_0_1},

 {255, ELITE_STRENGTH, _1_0_0},
 {255, ELITE_STRENGTH, _0_1_0},
 {255, ELITE_STRENGTH, _N_0_0},
 {255, ELITE_STRENGTH, _0_N_0},

 {  0, ELITE_STRENGTH, _1_0_0},
 {255, ELITE_STRENGTH, _0_0_N},

 {  0, ELITE_STRENGTH, _0_1_0},
 {255, ELITE_STRENGTH, _0_0_1},
 {  0, ELITE_STRENGTH, _N_0_0},
 {255, ELITE_STRENGTH, _0_0_N},

 // than the 'inner' cell
 {0, 100, _1_0_0},
 {0, 80, _0_0_1},

 {255, 40, _1_0_0},
 {255, 80, _0_0_1},
 {255, 40, _N_0_0},
 {255, 80, _0_0_N},

 {255, ELITE_STRENGTH, _0_N_0},
 {255, 40, _1_0_0},
 {255, 80, _0_0_1},
 {255, 40, _N_0_0},
 {255, 80, _0_0_N},

 {0, 40, _1_0_0},
 {255, ELITE_STRENGTH, _0_1_0},
 {0, 80, _0_0_1},
 {255, ELITE_STRENGTH, _0_N_0},
 {0, 40, _N_0_0},
 {255, ELITE_STRENGTH, _0_1_0},

 {  1, 0, _0_0_N}
};

initElite()
{
 cosx = cosinus3d[angle_x];
 sinx = sinus3d[angle_x];
 cosy = cosinus3d[angle_y];
 siny = sinus3d[angle_y];
 cosz = cosinus3d[angle_z];
 sinz = sinus3d[angle_z];

 // per single vector about 250 - 300 cycles
 //...  all used vector combinations

 // set to init for Mcube!
 INIT_1_0_0_A;
 INIT_0_1_0_A;
 INIT_0_0_1_A;
 INIT_N_1_N;

 INIT_1_1_1;
 INIT_N_1_1_I;
 INIT_1_1_N_A;
 INIT_1_N_1_A;
}

unsigned short delta_x; // position of 'satellite'
unsigned short delta_y;
unsigned short counter;

void elite_demo()
{
  angle_x = 0;
  angle_y = 0;
  angle_z = 0;
  ym_init(&ELITE1_data);

  delta_x = 0;
  delta_y = 0;
  counter = 0;
  while (true)
  {
    start_one_vectrex_round();  /* start vectrex round */
    intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

    initElite();
    zero_beam();
    move_to(0, 0);
    draw_3ds(elite);
    zero_beam();
    delta_x = cosinus[counter];
    delta_y = sinus[counter];
    zero_beam();
    set_scale(120);
    move_to(delta_x, delta_y);
    draw_3ds(pyramid); // satellite rotates with the cube...
    zero_beam();

    if (joystick1_button4)
    {
      angle_x++;
      if (angle_x == 64) angle_x = 0;
    }
    if (joystick1_button3)
    {
      angle_y++;
      if (angle_y == 64) angle_y = 0;
    }
    if (joystick1_button2)
    {
      angle_z++;
      if (angle_z == 64) angle_z = 0;
    }
    if (joystick1_button1)
    {
      break;
    }
    counter++;
    if (counter == 128)
    {
     counter = 0;
    }
    read_buttons();
  }
}

