#define PYRAMID_STRENGTH2 10
#define CUBE_STRENGTH2 40
#define TRIANGLE_STRENGTH2 20

// using scale to double line saves cycles
// in this case about 150
struct Line3d pyramid2[] =
{
   {0, 2*PYRAMID_STRENGTH2, _0_0_N},
   {0, 2*PYRAMID_STRENGTH2, _N_0_0},
   {0, 1*PYRAMID_STRENGTH2, _0_1_0},

   {255, 4*PYRAMID_STRENGTH2, _1_0_0},
   {255, 4*PYRAMID_STRENGTH2, _0_0_1},
   {255, 4*PYRAMID_STRENGTH2, _N_0_0},
   {255, 4*PYRAMID_STRENGTH2, _0_0_N},

   {255, 2*PYRAMID_STRENGTH2, _1_1_1},

   {255, 2*PYRAMID_STRENGTH2, _1_N_1},
   {  0, 2*PYRAMID_STRENGTH2, _N_1_N},
   {255, 2*PYRAMID_STRENGTH2, _N_N_1},
   {  0, 2*PYRAMID_STRENGTH2, _1_1_N},
   {255, 2*PYRAMID_STRENGTH2, _1_N_N},

   {  1, 0, _0_0_N}
};

struct Line3d cube2[] =
{
 {0, CUBE_STRENGTH2/2, _N_1_N},
 {255, CUBE_STRENGTH2, _1_0_0},
 {255, CUBE_STRENGTH2, _0_1_0},
 {255, CUBE_STRENGTH2, _N_0_0},
 {255, CUBE_STRENGTH2, _0_N_0},

 {255, CUBE_STRENGTH2, _0_0_1},

 {255, CUBE_STRENGTH2, _1_0_0},
 {255, CUBE_STRENGTH2, _0_1_0},
 {255, CUBE_STRENGTH2, _N_0_0},
 {255, CUBE_STRENGTH2, _0_N_0},

 {  0, CUBE_STRENGTH2, _1_0_0},
 {255, CUBE_STRENGTH2, _0_0_N},

 {  0, CUBE_STRENGTH2, _0_1_0},
 {255, CUBE_STRENGTH2, _0_0_1},
 {  0, CUBE_STRENGTH2, _N_0_0},
 {255, CUBE_STRENGTH2, _0_0_N},

 {  1, 0, _0_0_N}
};

struct Line3d triangle[] =
{
   {0, 1*TRIANGLE_STRENGTH2, _0_0_N},
   {0, 1*TRIANGLE_STRENGTH2, _0_N_0},

 {255, TRIANGLE_STRENGTH2*2, _1_0_1},
 {255, TRIANGLE_STRENGTH2*4, _N_0_0},

 {255, TRIANGLE_STRENGTH2*2, _1_0_N},

 {255, TRIANGLE_STRENGTH2*2, _0_1_0},

 {255, TRIANGLE_STRENGTH2*2, _1_0_1},
 {255, TRIANGLE_STRENGTH2*4, _N_0_0},
 {255, TRIANGLE_STRENGTH2*2, _1_0_N},

 {0, TRIANGLE_STRENGTH2*2, _1_0_1},
 {255, TRIANGLE_STRENGTH2*2, _0_N_0},
 {0, TRIANGLE_STRENGTH2*4, _N_0_0},
 {255, TRIANGLE_STRENGTH2*2, _0_1_0},

 {  1, 0, _0_0_N}
};

initlast()
{
 cosx = cosinus3d[angle_x];
 sinx = sinus3d[angle_x];
 cosy = cosinus3d[angle_y];
 siny = sinus3d[angle_y];
 cosz = cosinus3d[angle_z];
 sinz = sinus3d[angle_z];

 // per single vector about 250 - 300 cycles
 //...  all used vector combinations

 // set to init for Mcube!
 INIT_1_0_0_A;
 INIT_0_1_0_A;
 INIT_0_0_1_A;
 INIT_N_1_N_A;

 INIT_1_1_1;
 INIT_N_1_1_I;
 INIT_1_1_N_A;

 INIT_1_0_1;
 INIT_1_0_N;
}

void last_demo()
{
  angle_x = 0;
  angle_y = 0;
  angle_z = 0;
  ym_init(&BITTLOAD_data);

  while (true)
  {
    start_one_vectrex_round();  /* start vectrex round */
    intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

    initlast();

    zero_beam();
    set_scale(200);
    move_to(-60, -30);
    draw_3ds(cube2);

    zero_beam();
    set_scale(200);
    move_to(-90, -30);
    draw_3ds(pyramid2);

    zero_beam();
    set_scale(200);
    move_to(-30, -30);
    draw_3ds(triangle);

    zero_beam();
    set_scale(200);
    move_to(0, -30);
    draw_3ds(cube2);

    zero_beam();
    set_scale(200);
    move_to(30, -30);
    draw_3ds(pyramid2);

    zero_beam();
    set_scale(200);
    move_to(60, -30);
    draw_3ds(triangle);

    zero_beam();
    set_scale(200);
    move_to(90, -30);
    draw_3ds(triangle);


    zero_beam();
    set_scale(200);
    move_to(-60, 30);
    draw_3ds(cube2);

    zero_beam();
    set_scale(200);
    move_to(-90, 30);
    draw_3ds(pyramid2);

    zero_beam();
    set_scale(200);
    move_to(-30, 30);
    draw_3ds(triangle);

    zero_beam();
    set_scale(200);
    move_to(0, 30);
    draw_3ds(cube2);

    zero_beam();
    set_scale(200);
    move_to(30, 30);
    draw_3ds(pyramid2);

    zero_beam();
    set_scale(200);
    move_to(60, 30);
    draw_3ds(triangle);

    zero_beam();
    set_scale(200);
    move_to(90, 30);
    draw_3ds(triangle);

    if (joystick1_button4)
    {
      angle_x++;
      if (angle_x == 64) angle_x = 0;
    }
    if (joystick1_button3)
    {
      angle_y++;
      if (angle_y == 64) angle_y = 0;
    }
    if (joystick1_button2)
    {
      angle_z++;
      if (angle_z == 64) angle_z = 0;
    }
    if (joystick1_button1)
    {
      break;
    }
    read_buttons();
  }
}

