#ifndef CLINES_H
#define CLINES_H

/*
 * Include some standard vectrex functions first!
 */
#include <vectrex.h>

/*
 * The linker/assembler only supports labels up to 8 character
 * (after that it discards). I truncated the labels to take that
 * into account... but it's not so readable anymore...
 */

void draw_cl(const void *data) /* 'C' callable init, data */
{                               /* as parameter */
  SET_U_REG(data);              /* set text address to reg U */
  draw_cl_();                   /* and call the asm init... */
}

#endif
