#ifndef YMSOUND_H
#define YMSOUND_H

/*
 * Include some standard vectrex functions first!
 */
#include <vectrex.h>

/*
 * The linker/assembler only supports labels up to 8 character
 * (after that it discards). I truncated the labels to take that
 * into account... but it's not so readable anymore...
 */
extern int ym_cdata;
void ym_sound(void);
/*
c_smallies noch in library einbauen, so dass
kein code im header ist

hier und in clines...
*/

void ym_init(const void *data)  /* 'C' callable init, sound data */
{                               /* as parameter */
  SET_U_REG(data);              /* set text address to reg U */
  _ym_init();                   /* and call the asm init... */
}
#endif
