#ifndef _MAN_H_
#define _MAN_H_



#define MAN_SCALE 5

#define MAN_SIZE (25)

#define ARM_LEFT_OFFSET_X -30
#define ARM_LEFT_OFFSET_Y -9
#define ARM_RIGHT_OFFSET_X 40
#define ARM_RIGHT_OFFSET_Y 0
#define FACE_OFFSET_X -24
#define FACE_OFFSET_Y 25

const signed char face[]=
{
                11,
                 0 * MAN_SIZE,  5 * MAN_SIZE,
                -2 * MAN_SIZE, -1 * MAN_SIZE,
                 1 * MAN_SIZE, -1 * MAN_SIZE,
                 0 * MAN_SIZE,  1 * MAN_SIZE,
                -1 * MAN_SIZE,  0 * MAN_SIZE,
                -3 * MAN_SIZE, -1 * MAN_SIZE,
                 0 * MAN_SIZE, -1 * MAN_SIZE,
                 3 * MAN_SIZE, -1 * MAN_SIZE,
                 1 * MAN_SIZE,  0 * MAN_SIZE,
                 0 * MAN_SIZE,  1 * MAN_SIZE,
                -1 * MAN_SIZE, -1 * MAN_SIZE,
                 2 * MAN_SIZE, -1 * MAN_SIZE
};

const signed char up1[]=
{
                  6,
                  0 * MAN_SIZE,  2 * MAN_SIZE,
                 -4 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -2 * MAN_SIZE,
                  0 * MAN_SIZE,  2 * MAN_SIZE,
                 -1 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -2 * MAN_SIZE,
                  5 * MAN_SIZE,  0 * MAN_SIZE
};

const signed char up2[]=
{
                  6,
                  0 * MAN_SIZE,  2 * MAN_SIZE,
                 -3 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -2 * MAN_SIZE,
                  0 * MAN_SIZE,  2 * MAN_SIZE,
                 -2 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -2 * MAN_SIZE,
                  5 * MAN_SIZE,  0 * MAN_SIZE
};

const signed char up3[]=
{
                  6,
                  0 * MAN_SIZE,  2 * MAN_SIZE,
                 -2 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -2 * MAN_SIZE,
                  0 * MAN_SIZE,  2 * MAN_SIZE,
                 -3 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -2 * MAN_SIZE,
                  5 * MAN_SIZE,  0 * MAN_SIZE
};

const signed char up4[]=
{
                  6,
                  0 * MAN_SIZE,  2 * MAN_SIZE,
                 -1 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -2 * MAN_SIZE,
                  0 * MAN_SIZE,  2 * MAN_SIZE,
                 -4 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -2 * MAN_SIZE,
                  5 * MAN_SIZE,  0 * MAN_SIZE
};

const signed char up5[]=
{
                  3,
                  0 * MAN_SIZE,  2 * MAN_SIZE,
                 -5 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -2 * MAN_SIZE,
                  5 * MAN_SIZE,  0 * MAN_SIZE
};

const signed char up6[]=
{
                  3,
                  0 * MAN_SIZE,  2 * MAN_SIZE,
                 -5 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -2 * MAN_SIZE,
                  5 * MAN_SIZE,  0 * MAN_SIZE
};

const signed char wheel1[]=
{
                13,
                -1 * MAN_SIZE, -2 * MAN_SIZE,
                -2 * MAN_SIZE, -1 * MAN_SIZE,
                -2 * MAN_SIZE,  0 * MAN_SIZE,
                 0 * MAN_SIZE,  2 * MAN_SIZE,
                -2 * MAN_SIZE, -1 * MAN_SIZE,
                -1 * MAN_SIZE,  2 * MAN_SIZE,
                 0 * MAN_SIZE,  2 * MAN_SIZE,
                 1 * MAN_SIZE,  2 * MAN_SIZE,
                 2 * MAN_SIZE,  1 * MAN_SIZE,
                 2 * MAN_SIZE,  0 * MAN_SIZE,
                 0 * MAN_SIZE, -2 * MAN_SIZE,
                 2 * MAN_SIZE,  1 * MAN_SIZE,
                 1 * MAN_SIZE, -2 * MAN_SIZE,
                 0 * MAN_SIZE, -2 * MAN_SIZE
};

const signed char wheel2[]=
{
                13,
                -1 * MAN_SIZE, -2 * MAN_SIZE,
                -2 * MAN_SIZE, -1 * MAN_SIZE,
                -1 * MAN_SIZE,  2 * MAN_SIZE,
                -1 * MAN_SIZE, -2 * MAN_SIZE,
                -2 * MAN_SIZE,  1 * MAN_SIZE,
                -1 * MAN_SIZE,  2 * MAN_SIZE,
                 0 * MAN_SIZE,  2 * MAN_SIZE,
                 1 * MAN_SIZE,  2 * MAN_SIZE,
                 2 * MAN_SIZE,  1 * MAN_SIZE,
                 1 * MAN_SIZE, -2 * MAN_SIZE,
                 1 * MAN_SIZE,  2 * MAN_SIZE,
                 2 * MAN_SIZE, -1 * MAN_SIZE,
                 1 * MAN_SIZE, -2 * MAN_SIZE,
                 0 * MAN_SIZE, -2 * MAN_SIZE
};

const signed char wheel3[]=
{
                13,
                -1 * MAN_SIZE, -2 * MAN_SIZE,
                -2 * MAN_SIZE,  1 * MAN_SIZE,
                 0 * MAN_SIZE, -2 * MAN_SIZE,
                -2 * MAN_SIZE,  0 * MAN_SIZE,
                -2 * MAN_SIZE,  1 * MAN_SIZE,
                -1 * MAN_SIZE,  2 * MAN_SIZE,
                 0 * MAN_SIZE,  2 * MAN_SIZE,
                 1 * MAN_SIZE,  2 * MAN_SIZE,
                 2 * MAN_SIZE, -1 * MAN_SIZE,
                 0 * MAN_SIZE,  2 * MAN_SIZE,
                 2 * MAN_SIZE,  0 * MAN_SIZE,
                 2 * MAN_SIZE, -1 * MAN_SIZE,
                 1 * MAN_SIZE, -2 * MAN_SIZE,
                 0 * MAN_SIZE, -2 * MAN_SIZE
};

const signed char wheel4[]=
{
                13,
                -2 * MAN_SIZE,  0 * MAN_SIZE,
                 1 * MAN_SIZE, -2 * MAN_SIZE,
                -2 * MAN_SIZE, -1 * MAN_SIZE,
                -2 * MAN_SIZE,  0 * MAN_SIZE,
                -2 * MAN_SIZE,  1 * MAN_SIZE,
                -1 * MAN_SIZE,  2 * MAN_SIZE,
                 0 * MAN_SIZE,  2 * MAN_SIZE,
                 2 * MAN_SIZE,  0 * MAN_SIZE,
                -1 * MAN_SIZE,  2 * MAN_SIZE,
                 2 * MAN_SIZE,  1 * MAN_SIZE,
                 2 * MAN_SIZE,  0 * MAN_SIZE,
                 2 * MAN_SIZE, -1 * MAN_SIZE,
                 1 * MAN_SIZE, -2 * MAN_SIZE,
                 0 * MAN_SIZE, -2 * MAN_SIZE,
};

const signed char wheel5[]=
{
                13,
                -1 * MAN_SIZE, -2 * MAN_SIZE,
                -2 * MAN_SIZE, -1 * MAN_SIZE,
                -2 * MAN_SIZE,  0 * MAN_SIZE,
                -2 * MAN_SIZE,  1 * MAN_SIZE,
                -1 * MAN_SIZE,  2 * MAN_SIZE,
                 2 * MAN_SIZE,  1 * MAN_SIZE,
                -2 * MAN_SIZE,  1 * MAN_SIZE,
                 1 * MAN_SIZE,  2 * MAN_SIZE,
                 2 * MAN_SIZE,  1 * MAN_SIZE,
                 2 * MAN_SIZE,  0 * MAN_SIZE,
                 2 * MAN_SIZE, -1 * MAN_SIZE,
                 1 * MAN_SIZE, -2 * MAN_SIZE,
                -2 * MAN_SIZE, -1 * MAN_SIZE,
                 2 * MAN_SIZE, -1 * MAN_SIZE
};

const signed char wheel6[]=
{
                13,
                -1 * MAN_SIZE, -2 * MAN_SIZE,
                -2 * MAN_SIZE, -1 * MAN_SIZE,
                -2 * MAN_SIZE,  0 * MAN_SIZE,
                -2 * MAN_SIZE,  1 * MAN_SIZE,
                 1 * MAN_SIZE,  2 * MAN_SIZE,
                -2 * MAN_SIZE,  0 * MAN_SIZE,
                 0 * MAN_SIZE,  2 * MAN_SIZE,
                 1 * MAN_SIZE,  2 * MAN_SIZE,
                 2 * MAN_SIZE,  1 * MAN_SIZE,
                 2 * MAN_SIZE,  0 * MAN_SIZE,
                 2 * MAN_SIZE, -1 * MAN_SIZE,
                -1 * MAN_SIZE, -2 * MAN_SIZE,
                 2 * MAN_SIZE,  0 * MAN_SIZE,
                 0 * MAN_SIZE, -2 * MAN_SIZE
};

#define ARMS_ANIM_MAX 6
#define BODY_ANIM_MAX 6

const signed char * body[BODY_ANIM_MAX]=
{
  wheel1,
  wheel2,
  wheel3,
  wheel4,
  wheel5,
  wheel6
};

const signed char * arms[ARMS_ANIM_MAX]=
{
  up1,
  up2,
  up3,
  up4,
  up5,
  up6
};



#endif