/* Generated automatically by the program `genoutput'
from the machine description file `md'.  */

#include "config.h"
#include <stdio.h>
#include "flags.h"
#include "rtl.h"
#include "regs.h"
#include "hard-reg-set.h"
#include "real.h"
#include "insn-config.h"

#include "conditions.h"
#include "insn-flags.h"
#include "insn-attr.h"

#include "insn-codes.h"

#include "recog.h"

#include "output.h"

static char *
output_2 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (GET_CODE (operands[0]) == MEM)
        return "tst\t%0\t;tstqi: MEM:%0";
    else
        return "tst%0\t\t;tstqi: R:%0";
}
}

static char *
output_4 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if ((REG_P (operands[0])) && (REG_P (operands[1]))) {
        output_asm_insn ("pshs\t%1\t;cmpsi: R:%1 with R:%0", operands);
        return "cmp%0\t,s++\t;cmpsi:";
    }
    if (GET_CODE (operands[0]) == REG)
        return "cmp%0\t%1\t;cmpsi:";
    else {
        cc_status.flags |= CC_REVERSED;
        return "cmp%1\t%0\t;cmpsi:(R)";
    }
}
}

static char *
output_5 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if ((REG_P (operands[0])) && (REG_P (operands[1]))) {
        output_asm_insn ("pshs\t%1\t;cmphi: R:%1 with R:%0", operands);
        return "cmp%0\t,s++\t;cmphi:";
    }
    if (GET_CODE (operands[0]) == REG)
        return "cmp%0\t%1\t;cmphi:";
    else {
        cc_status.flags |= CC_REVERSED;
        return "cmp%1\t%0\t;cmphi:(R)";
    }
}
}

static char *
output_6 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (GET_CODE (operands[0]) == REG)
      return "cmp%0\t%1\t;cmpqi:";
    else {
      cc_status.flags |= CC_REVERSED;
      return "cmp%1\t%0\t;cmpqi:(R)";
    }
}
}

static char *
output_7 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    return "ld%0\t#%1\t;movsi: #<symbol_ref> -> %0";
}
}

static char *
output_8 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (REG_P (operands[0])) {

        if (REG_P (operands[1])) {
            if (REGNO (operands[0]) != REGNO (operands[1]))
                return "tfr\t%1,%0\t;movsi: R:%1 -> R:%0";
            else
                return ";redundant movsi: R:%1 -> R:%0";
        }

        if ((operands[1] == const0_rtx) && (D_REG_P (operands[0])))
            return "clra\t\t;movsi: ZERO -> R:%0\n\tclrb";
        else
            return "ld%0\t%1\t;movsi: %1 -> R:%0";
    }

    if ((push_operand (operands[0], SImode))
        && (REG_P (operands[1])))
            return "pshs\t%1\t;movsi: push R:%1";

    if (REG_P (operands[1]))
        return "st%1\t%0\t;movsi: R:%1 -> %0";

    return ".bogus ;movsi: %1 -> %0";
}
}

static char *
output_9 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (REG_P (operands[0])) {

        if (REG_P (operands[1])) {
            if (REGNO (operands[0]) != REGNO (operands[1]))
                return "tfr\t%1,%0\t;movhi: R:%1 -> R:%0";
            else
                return ";redundant movhi: R:%1 -> R:%0";
        }

        if ((operands[1] == const0_rtx) && (D_REG_P (operands[0])))
            return "clra\t\t;movhi: ZERO -> R:%0\n\tclrb";
        else
            return "ld%0\t%1\t;movhi: %1 -> R:%0";
    }

    if ((push_operand (operands[0], SImode))
        && (REG_P (operands[1])))
            return "pshs\t%1\t;movhi: push R:%1";

    if (REG_P (operands[1]))
        return "st%1\t%0\t;movhi: R:%1 -> %0";

    return ".bogus ;movhi: %1 -> %0";
}
}

static char *
output_10 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (REG_P (operands[0])) {
        if (REG_P (operands[1])) {
            if (REGNO (operands[0]) != REGNO (operands[1]))
                return "tfr\t%1,%0\t;movqi: R:%1 -> R:%0";
            else
                return ";redundant movqi: R:%1 -> R:%0";
        }

        if (operands[1] == const0_rtx)
            return "clr%0\t\t;movqi: ZERO -> R:%0";
        else
            return "ld%0\t%1\t;movqi: %1 -> R:%0";
    }

    if (GET_CODE (operands[1]) == REG)
        return "st%1\t%0\t;movqi: R:%1 -> %0";

    if ((push_operand (operands[0], QImode))
        && (GET_CODE (operands[1]) == REG))
        return "pshs\t%0\t;movqi: push R:%0";
    else
        return ".bogus ;movqi: %1 -> %0";
}
}

static char *
output_11 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (REG_P (operands[0]) && (operands[1] == const0_rtx))
    return "clr%0\t\t;movmsb:";
  if ((REG_P (operands[0])) && (D_REG_P (operands[1])))
    return "tfr\ta,%0\t;movmsb:";
  if (D_REG_P (operands[1]) && (GET_CODE (operands[0]) == MEM))
    return "sta\t%0\t;movmsb:";
  if (REG_P (operands[0]) && (GET_CODE (operands[1]) == MEM))
    return "ld%0\t%1\t;movmsb:";
  else
    return ".bogus ;movmsb: %1 -> %0";
}
}

static char *
output_12 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (REG_P (operands[0])) {
        if (operands[1] == const0_rtx)
            return "clr%0\t\t;movlsb: ZERO -> R:%0";
        if (D_REG_P (operands[1]))
            return "tfr\tb,%0\t;movlsb: R:%1 -> R:%0";
        if (GET_CODE (operands[1]) == MEM)
            return "ld%0\t%L1\t;movlsb: %1 -> R:%0 (with corrected memadress)";
  }
  if (D_REG_P (operands[1]) && (GET_CODE (operands[0]) == MEM))
    return "stb\t%0\t;movlsb: R:%1 -> %0";
  else
    return ".bogus ;movlsb: %1 -> %0";
}
}

static char *
output_13 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (REG_P (operands[0])) {
        if (operands[1] == const0_rtx)
            return "clr%0\t\t;movlsbqihi: ZERO -> R:%0";
        if (D_REG_P (operands[1]))
            return "tfr\tb,%0\t;movlsbqihi: R:%1 -> R:%0";
        if (GET_CODE (operands[1]) == MEM)
            return "ld%0\t%L1\t;movlsbqihi: %1 -> R:%0 (with corrected memadress)";
  }
  if (D_REG_P (operands[1]) && (GET_CODE (operands[0]) == MEM))
    return "stb\t%0\t;movlsbqihi: R:%1 -> %0";
  else
    return ".bogus ;movlsbqihi: %1 -> %0";
}
}

static char *
output_14 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (REG_P (operands[0])) {
        if (operands[1] == const0_rtx)
            return "clr%0\t\t;movlsb: ZERO -> R:%0";
        if (D_REG_P (operands[1]))
            return "tfr\tb,%0\t;movlsb: R:%1 -> R:%0";
        if (GET_CODE (operands[1]) == MEM)
            return "ld%0\t%1\t;movlsb: %1 -> R:%0 (with uncorrected memadress)";
  }
  if (D_REG_P (operands[1]) && (GET_CODE (operands[0]) == MEM))
    return "stb\t%0\t;movlsb: R:%1 -> %0";
  else
    return ".bogus ;movlsb: %1 -> %0";
} 
}

static char *
output_15 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (REG_P (operands[0])) {
    if (operands[1] == const0_rtx)
        return "clrb\t\t;movstricthi: ZERO -> R:%0";
    if (REG_P (operands[1]))
        return "tfr\t%1,b\t;movstricthi: R:%1 -> R:%0";
    else
        return "ldb\t%L1\t;movstricthi: %1 -> R:%0";
  }
  if (REG_P (operands[1]) && (GET_CODE (operands[0]) == MEM))
    return "stb\t%L0\t;movstricthi: R:%1 -> %0";
  else
    return ".bogus ;movstricthi: %1 -> %0";
}
}

static char *
output_19 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (REG_P (operands[1])) {
        if (REGNO (operands[1]) == 8)
            output_asm_insn ("tfr\ta,b\t;extendqisi: R:%1 -> R:%0\n\tsex", operands);
        else
            output_asm_insn ("sex\t\t;extendqisi: R:%1 -> R:%0", operands);
    }
    else {
        output_asm_insn ("ldb\t%1\t;extendqisi: %1 -> R:%0\n\tsex", operands);
    }
    return "";
}
}

static char *
output_20 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (REG_P (operands[1])) {
        if (REGNO (operands[1]) == 8)
            output_asm_insn ("tfr\ta,b\t;extendqihi: R:%1 -> R:%0\n\tsex", operands);
        else
            output_asm_insn ("sex\t\t;extendqihi: R:%1 -> R:%0", operands);
    }
    else {
        output_asm_insn ("ldb\t%1\t;extendqihi: %1 -> R:%0\n\tsex", operands);
    }
    return "";
}
}

static char *
output_21 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (D_REG_P (operands[0])) {
        if (REG_P (operands[1])) {
            if (REGNO (operands[1]) == 8)
                output_asm_insn ("tfr\ta,b", operands);
            return "clra\t\t;zero_extendhisi: R:%1 -> R:%0";
        }
        if (GET_CODE (operands[1]) == MEM)
            return "ldb\t%1\t;zero_extendhisi: %1 -> R:d\n\tclra";
    }

    if ((REG_P (operands[1])) && (GET_CODE (operands[0]) == MEM))
        return "clr\t%0\t;zero_extendhisi: R:%1 -> %0\n\tst%1\t%L0";

    if ((GET_CODE (operands[0]) == MEM) && (GET_CODE (operands[1]) == MEM)) {
        return "clr\t%0\t;zero_extendhisi: R:%1 -> %0\n\tlda\t%1\n\tsta\t%L0";
    }
    else
        return ".bogus ;zero_extendhisi: %1 -> %0";
}
}

static char *
output_22 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (D_REG_P (operands[0])) {
        if (REG_P (operands[1])) {
            if (REGNO (operands[1]) == 8)
                output_asm_insn ("tfr\ta,b", operands);
            return "clra\t\t;zero_extendqihi: R:%1 -> R:%0";
        }
        if (GET_CODE (operands[1]) == MEM)
            return "ldb\t%1\t;zero_extendqihi: %1 -> R:d\n\tclra";
    }

    if ((REG_P (operands[1])) && (GET_CODE (operands[0]) == MEM))
        return "clr\t%0\t;zero_extendqihi: R:%1 -> %0\n\tst%1\t%L0";

    if ((GET_CODE (operands[0]) == MEM) && (GET_CODE (operands[1]) == MEM)) {
        return "clr\t%0\t;zero_extendqihi: R:%1 -> %0\n\tlda\t%1\n\tsta\t%L0";
    }
    else
        return ".bogus ;zero_extendqihi2: %1 -> %0";
}
}

static char *
output_23 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (D_REG_P (operands[0])) {
        return "add%0\t%2\t;addsi: R:%0 += %2";
    }
    if ((A_REG_P (operands[0])) && (D_REG_P (operands[2])))
        return "lea%0\t%2,%1\t;addsi: R:%0 = R:%1 + R:%2";
    else
        return "lea%0\t%a2,%1\t;addsi: R:%0 = R:%1 + %2";
}
}

static char *
output_24 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if ((D_REG_P (operands[0])) && (REG_P (operands[2]))) {
        output_asm_insn ("pshs\t%2\t;addhi: R:%0 += R:%2", operands);
        return "add%0\t,s++";
    }

    if (D_REG_P (operands[0])) {
        return "add%0\t%2\t;addhi: R:%0 += %2";
    }
    if(A_REG_P (operands[0])){
        if(A_REG_P (operands[1])){
            if(GET_CODE (operands[2]) == MEM){
              output_asm_insn ("exg\td,%0\t;addhi: R:%0 = R:%1 + %2",
                                                operands);
              output_asm_insn ("addd\t%2", operands);
              return "exg\td,%0";
            }
            else if(D_REG_P (operands[2]))
                return "lea%0\t%2,%1\t;addhi: R:%0 = R:%1 + R:%2";
            else if(A_REG_P (operands[2])){
              output_asm_insn ("pshs\td\t;addhi: R:%0 = R:%1 + R:%2",
                                                operands);
              output_asm_insn ("tfr\t%1,d", operands);
              output_asm_insn ("lea%0\td,%2", operands);
              return "puls\td";
            }
            else
              return "lea%0\t%a2,%1\t;addhi: R:%0 = R:%1 + %2";
        }
        else{
            if(D_REG_P (operands[1]))
                return "lea%0\t%1,%2\t;addhi: R:%0 = R:%2 + R:%1";
            else
                return "lea%0\t%a1,%2\t;addhi: R:%0 = R:%2 + %1";
        }
    }
    else
        return ".bogus";
}
}

static char *
output_25 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if ((GET_CODE (operands[0]) == MEM) && (operands[2] == const1_rtx))
        return "inc\t%0\t;addqi: %0 += 1";
    if ((GET_CODE (operands[0]) == REG) && (operands[2] == const1_rtx))
        return "inc%0\t\t;addqi: R:%0 += 1";
    else
        return "add%0\t%2\t;addqi: R:%0 += %2";
}
}

static char *
output_26 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if ((D_REG_P (operands[0])) && (REG_P (operands[2]))) {
        output_asm_insn ("pshs\t%2\t;subsi: R:%0 -= R:%2", operands);
        return "sub%0\t,s++";
    }
    if (D_REG_P (operands[0])) {
        return "sub%0\t%2\t;subsi: R:%0 -= %2";
    }
    else
        return "lea%0\t%n2,%1\t;subsi: R:%0 = R:%1 + %n2";
}
}

static char *
output_28 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if ((D_REG_P (operands[0])) && (REG_P (operands[2]))) {
        output_asm_insn ("pshs\t%2\t;subhi: R:%0 -= R:%2", operands);
        return "sub%0\t,s++";
    }
    if (D_REG_P (operands[0])) {
        return "sub%0\t%2\t;subhi: R:%0 -= %2";
    }
    else
        return "lea%0\t%n2,%1\t;subhi: R:%0 = R:%1 + %n2";
}
}

static char *
output_29 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (operands[2] == const1_rtx)
        return "dec%0\t\t;subhi: R:%0 -= 1";
    else
      return "sub%0\t%2\t;subhi: R:%0 -= %2";
}
}

static char *
output_30 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  output_asm_insn ("pshs\t%1,%2\t; sichern Operanden R:%1,R:%2", operands);
  output_asm_insn ("jsr\t_mulhi3\t; Aufruf mulhi, Ergebnis in D",
                    operands);
  return "leas\t4,s\t; Aufraeumen Stack";
}
}

static char *
output_31 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    output_asm_insn ("lda\t%2\t;mulhi: R:%0 = R:%0 * %2", operands);
    return "mul";
}
}

static char *
output_36 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;
    rtx xoperands[4];

    if (GET_CODE (operands[2]) == CONST_INT) {
        xoperands[0] = operands[0];
        xoperands[1] = operands[1];
        xoperands[3] = operands[2];
        xoperands[2] =
            gen_rtx (CONST_INT, SImode,
            (INTVAL (operands[2]) >> 8) & 0xff);
        output_asm_insn ("anda\t%2\t;andsi: R:%0 AND %3", xoperands);
        xoperands[2] =
            gen_rtx (CONST_INT, SImode, INTVAL (operands[2]) & 0xff);
        output_asm_insn ("andb\t%2", xoperands);
    }
    else {
        output_asm_insn ("anda\t%2\t;andsi: R:%0 AND %2", operands);
        output_asm_insn ("andb\t%L2", operands);
    }
    return "";
}
}

static char *
output_37 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;
    rtx xoperands[4];

    if (GET_CODE (operands[2]) == CONST_INT) {
        xoperands[0] = operands[0];
        xoperands[1] = operands[1];
        xoperands[3] = operands[2];
        xoperands[2] =
            gen_rtx (CONST_INT, HImode,
            (INTVAL (operands[2]) >> 8) & 0xff);
        output_asm_insn ("anda\t%2\t;andhi: R:%0 AND %3", xoperands);
        xoperands[2] =
            gen_rtx (CONST_INT, HImode, INTVAL (operands[2]) & 0xff);
        output_asm_insn ("andb\t%2", xoperands);
    }
    else {
        output_asm_insn ("anda\t%2\t;andhi: R:%0 AND %2", operands);
        output_asm_insn ("andb\t%L2", operands);
    }
    return "";
}
}

static char *
output_39 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;
    rtx xoperands[3];

    if (GET_CODE (operands[2]) == CONST_INT) {
        xoperands[0] = operands[0];
        xoperands[1] = operands[1];
        xoperands[2] =
            gen_rtx (CONST_INT, SImode,
            (INTVAL (operands[2]) >> 8) & 0xff);
        output_asm_insn ("ora\t%2\t;iorsi: %0 OR %2", xoperands);
        xoperands[2] =
            gen_rtx (CONST_INT, SImode, INTVAL (operands[2]) & 0xff);
        output_asm_insn ("orb\t%2", xoperands);
    }
    else {
        output_asm_insn ("ora\t%2\t;iorsi: %0 OR %2", operands);
        output_asm_insn ("orb\t%L2", operands);
    }
    return "";
}
}

static char *
output_40 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;
    rtx xoperands[3];

    if (GET_CODE (operands[2]) == CONST_INT) {
        xoperands[0] = operands[0];
        xoperands[1] = operands[1];
        xoperands[2] =
            gen_rtx (CONST_INT, HImode,
            (INTVAL (operands[2]) >> 8) & 0xff);
        output_asm_insn ("ora\t%2\t;iorhi: %0 OR %2", xoperands);
        xoperands[2] =
            gen_rtx (CONST_INT, HImode, INTVAL (operands[2]) & 0xff);
        output_asm_insn ("orb\t%2", xoperands);
    }
    else {
        output_asm_insn ("ora\t%2\t;iorhi: %0 OR %2", operands);
        output_asm_insn ("orb\t%L2", operands);
    }
    return "";
}
}

static char *
output_42 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;
    rtx xoperands[3];

    if (GET_CODE (operands[2]) == CONST_INT) {
        xoperands[0] = operands[0];
        xoperands[1] = operands[1];
        xoperands[2] =
            gen_rtx (CONST_INT, SImode,
            (INTVAL (operands[2]) >> 8) & 0xff);
        output_asm_insn ("eora\t%2\t;xorsi: %0 XOR %2", xoperands);
        xoperands[2] =
            gen_rtx (CONST_INT, SImode, INTVAL (operands[2]) & 0xff);
        output_asm_insn ("eorb\t%2", xoperands);
    }
    else {
        output_asm_insn ("eora\t%2\t;xorsi: %0 XOR %2", operands);
        output_asm_insn ("eorb\t%L2", operands);
    }
    return "";
}
}

static char *
output_43 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;
    rtx xoperands[3];

    if (GET_CODE (operands[2]) == CONST_INT) {
        xoperands[0] = operands[0];
        xoperands[1] = operands[1];
        xoperands[2] =
            gen_rtx (CONST_INT, HImode,
            (INTVAL (operands[2]) >> 8) & 0xff);
        output_asm_insn ("eora\t%2\t;xorhi: %0 XOR %2", xoperands);
        xoperands[2] =
            gen_rtx (CONST_INT, HImode, INTVAL (operands[2]) & 0xff);
        output_asm_insn ("eorb\t%2", xoperands);
    }
    else {
        output_asm_insn ("eora\t%2\t;xorhi: %0 XOR %2", operands);
        output_asm_insn ("eorb\t%L2", operands);
    }
    return "";
}
}

static char *
output_45 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (D_REG_P (operands[0])) {
        return "coma\t\t;negsi: R:%0\n\tcomb\n\taddd\t#1";
    }
    else if (A_REG_P (operands[0])) {
        output_asm_insn ("exg\td,%0\t;negsi: R:%0 = -(R:%0)", operands);
        return "coma\n\tcomb\n\taddd\t#1\n\texg\td,%0";
    }
    else {
        output_asm_insn ("com\t%0\t;negsi: %0\n\tcom\t%L0", operands);
        output_asm_insn ("inc\t%L0", operands);
        output_asm_insn ("bne\t%l0", operands);
        output_asm_insn ("inc\t%0", operands);
        ASM_OUTPUT_INTERNAL_LABEL (asm_out_file, "LI",
            CODE_LABEL_NUMBER (operands[0]));
        return "";
    }
}
}

static char *
output_46 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (D_REG_P (operands[0])) {
        return "coma\t\t;neghi: R:%0\n\tcomb\n\taddd\t#1";
    }
    else if (A_REG_P (operands[0])) {
        output_asm_insn ("exg\td,%0\t;neghi: R:%0 = -(R:%0)", operands);
        return "coma\n\tcomb\n\taddd\t#1\n\texg\td,%0";
    }
    else {
        output_asm_insn ("com\t%0\t;neghi: %0\n\tcom\t%L0", operands);
        output_asm_insn ("inc\t%L0", operands);
        output_asm_insn ("bne\t%l0", operands);
        output_asm_insn ("inc\t%0", operands);
        ASM_OUTPUT_INTERNAL_LABEL (asm_out_file, "LI",
            CODE_LABEL_NUMBER (operands[0]));
        return "";
    }
}
}

static char *
output_47 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (REG_P (operands[0]))
        return "neg%0\t\t;negqi: R:%0";
    else
        return "neg\t%0\t;negqi: %0";
}
}

static char *
output_49 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (REG_P (operands[0]))
        return "coma\t\t;comhi: R:%0\n\tcomb";
    else
        return "com\t%0\t;comhi: %0\n\tcom\t%L0";
}
}

static char *
output_50 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (REG_P (operands[0]))
        return "com%0\t\t;comqi: R:%0";
    else
        return "com\t%0\t;comqi: %0";
}
}

static char *
output_51 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;

    output_asm_insn ("\t\t;ashlsi: %0 by %2", operands);
    if (GET_CODE (operands[2]) == CONST_INT) {
        n = INTVAL (operands[2]) & 0x0f;
        while (n-- > 0) {
            if (D_REG_P (operands[0]))
                output_asm_insn ("aslb\n\trola", operands);
            else
                output_asm_insn ("asl\t%L0\n\trol\t%0", operands);
        }
    }
    else {
        output_asm_insn ("aslb\n\trola", operands);
        output_asm_insn ("lea%2\t-1,%2\t;decr shift count", operands);
        output_asm_insn ("bne .-4\t;loop", operands);
    }
    return "";
}
}

static char *
output_52 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;

    output_asm_insn ("\t\t;ashlhi: %0 by %2", operands);
    if (GET_CODE (operands[2]) == CONST_INT) {
        n = INTVAL (operands[2]) & 0x0f;
        while (n-- > 0) {
            if (D_REG_P (operands[0]))
                output_asm_insn ("aslb\n\trola", operands);
            else
                output_asm_insn ("asl\t%L0\n\trol\t%0", operands);
        }
    }
    else {
        output_asm_insn ("aslb\n\trola", operands);
        output_asm_insn ("lea%2\t-1,%2\t;decr shift count", operands);
        output_asm_insn ("bne .-4\t;loop", operands);
    }
    return "";
}
}

static char *
output_53 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;

    n = INTVAL (operands[2]) & 0x07;
    output_asm_insn ("\t\t;ashlqi: %0 by %2", operands);
    while (n-- > 0) {
        if (REG_P (operands[0]))
            output_asm_insn ("aslb", operands);
        else
            output_asm_insn ("asl\t%0", operands);
    }
     return "";
}
}

static char *
output_54 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;

    output_asm_insn ("\t\t;ashrsi: %0 by %2", operands);
    if (GET_CODE (operands[2]) == CONST_INT) {
        n = INTVAL (operands[2]) & 0x0f;
        while (n-- > 0) {
            if (D_REG_P (operands[0]))
                output_asm_insn ("asra\n\trorb", operands);
            else
                output_asm_insn ("asr\t%0\n\tror\t%L0", operands);
        }
    }
    else {
        output_asm_insn ("asra\n\trorb", operands);
        output_asm_insn ("lea%2\t-1,%2\t;decr shift count", operands);
        output_asm_insn ("bne .-4\t;loop", operands);
    }
     return "";
}
}

static char *
output_55 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;

    output_asm_insn ("\t\t;ashrhi: %0 by %2", operands);
    if (GET_CODE (operands[2]) == CONST_INT) {
        n = INTVAL (operands[2]) & 0x0f;
        while (n-- > 0) {
            if (D_REG_P (operands[0]))
                output_asm_insn ("asra\n\trorb", operands);
            else
                output_asm_insn ("asr\t%0\n\tror\t%L0", operands);
        }
    }
    else {
        output_asm_insn ("asra\n\trorb", operands);
        output_asm_insn ("lea%2\t-1,%2\t;decr shift count", operands);
        output_asm_insn ("bne .-4\t;loop", operands);
    }
     return "";
}
}

static char *
output_56 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;

    n = INTVAL (operands[2]) & 0x07;
    output_asm_insn ("\t\t;ashrqi: %0 by %2", operands);
    while (n-- > 0) {
        if (Q_REG_P (operands[0]))
            output_asm_insn ("asrb", operands);
        else
            output_asm_insn ("asr\t%0", operands);
    }
     return "";
}
}

static char *
output_57 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;

    output_asm_insn ("\t\t;lshrsi: %0 by %2", operands);
    if (GET_CODE (operands[2]) == CONST_INT) {
        n = INTVAL (operands[2]) & 0x0f;
        while (n-- > 0) {
            if (D_REG_P (operands[0]))
                output_asm_insn ("lsra\n\trorb", operands);
            else
                output_asm_insn ("lsr\t%0\n\tror\t%L0", operands);
        }
    }
    else {
        output_asm_insn ("lsra\n\trorb", operands);
        output_asm_insn ("lea%2\t-1,%2\t;decr shift count", operands);
        output_asm_insn ("bne .-4\t;loop", operands);
    }

     return "";
}
}

static char *
output_58 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;

    output_asm_insn ("\t\t;lshrhi: %0 by %2", operands);
    if (GET_CODE (operands[2]) == CONST_INT) {
        n = INTVAL (operands[2]) & 0x0f;
        while (n-- > 0) {
            if (D_REG_P (operands[0]))
                output_asm_insn ("lsra\n\trorb", operands);
            else
                output_asm_insn ("lsr\t%0\n\tror\t%L0", operands);
        }
    }
    else {
        output_asm_insn ("lsra\n\trorb", operands);
        output_asm_insn ("lea%2\t-1,%2\t;decr shift count", operands);
        output_asm_insn ("bne .-4\t;loop", operands);
    }

     return "";
}
}

static char *
output_60 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;

    n = INTVAL (operands[2]) & 0x07;
    output_asm_insn ("\t\t;rotlhi: %0 by %2", operands);
    while (n-- > 0) {
        if (Q_REG_P (operands[0]))
            output_asm_insn ("rolb", operands);
        else
            output_asm_insn ("rol\t%0", operands);
    }
     return "";
}
}

static char *
output_61 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;

    n = INTVAL (operands[2]) & 0x07;
    output_asm_insn ("\t\t;rotlqi: %0 by %2", operands);
    while (n-- > 0) {
        if (Q_REG_P (operands[0]))
            output_asm_insn ("rolb", operands);
        else
            output_asm_insn ("rol\t%0", operands);
    }
     return "";
}
}

static char *
output_63 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;

    n = INTVAL (operands[2]) & 0x07;
    output_asm_insn ("\t\t;rotrhi: %0 by %2", operands);
    while (n-- > 0) {
        if (Q_REG_P (operands[0]))
            output_asm_insn ("rorb", operands);
        else
            output_asm_insn ("ror\t%0", operands);
    }
     return "";
}
}

static char *
output_64 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    int n;

    n = INTVAL (operands[2]) & 0x07;
    output_asm_insn ("\t\t;rotrqi: %0 by %2", operands);
    while (n-- > 0) {
        if (Q_REG_P (operands[0]))
            output_asm_insn ("rorb", operands);
        else
            output_asm_insn ("ror\t%0", operands);
    }
     return "";
}
}

static char *
output_65 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (A_REG_P (operands[0]))
       return "jmp\t,%0\t;V1 tablejump R:%0 (table %1)";
    else if (D_REG_P (operands[0]))
       return "pshs %0\n\tjmp\t[,s++]\t;V2 tablejump R:%0 (table %1)";
    else
       return "jmp\t[%0]\t;V3 tablejump %0 (table %1)";
}
}

static char *
output_66 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
        output_asm_insn ("jmp\t%l0", operands);
     return "";
}
}

static char *
output_67 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
        output_asm_insn ("jmp\t%l0", operands);
     return "";
}
}

static char *
output_68 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("bra\t%l0", operands);
    else
        output_asm_insn ("jmp\t%l0", operands);
    return "";
}
}

static char *
output_69 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("beq\t%l0", operands);
    else
        output_asm_insn ("lbeq\t%l0", operands);
    return "";
}
}

static char *
output_70 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("bne\t%l0", operands);
    else
        output_asm_insn ("lbne\t%l0", operands);
    return "";
}
}

static char *
output_71 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("bgt\t%l0", operands);
    else
        output_asm_insn ("lbgt\t%l0", operands);
    return "";
}
}

static char *
output_72 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("bhi\t%l0", operands);
    else
        output_asm_insn ("lbhi\t%l0", operands);
    return "";
}
}

static char *
output_73 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("blt\t%l0", operands);
    else
        output_asm_insn ("lblt\t%l0", operands);
    return "";
}
}

static char *
output_74 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("blo\t%l0", operands);
    else
        output_asm_insn ("lblo\t%l0", operands);
    return "";
}
}

static char *
output_75 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("bge\t%l0", operands);
    else
        output_asm_insn ("lbge\t%l0", operands);
    return "";
}
}

static char *
output_76 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("bhs\t%l0", operands);
    else
        output_asm_insn ("lbhs\t%l0", operands);
    return "";
}
}

static char *
output_77 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("ble\t%l0", operands);
    else
        output_asm_insn ("lble\t%l0", operands);
    return "";
}
}

static char *
output_78 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("bls\t%l0", operands);
    else
        output_asm_insn ("lbls\t%l0", operands);
    return "";
}
}

static char *
output_79 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("bne\t%l0\t;rev", operands);
    else
        output_asm_insn ("lbne\t%l0\t;rev", operands);
    return "";
}
}

static char *
output_80 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("beq\t%l0\t;rev", operands);
    else
        output_asm_insn ("lbeq\t%l0\t;rev", operands);
    return "";
}
}

static char *
output_81 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("ble\t%l0\t;rev", operands);
    else
        output_asm_insn ("lble\t%l0\t;rev", operands);
    return "";
}
}

static char *
output_82 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("bls\t%l0\t;rev", operands);
    else
        output_asm_insn ("lbls\t%l0\t;rev", operands);
    return "";
}
}

static char *
output_83 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("bge\t%l0\t;rev", operands);
    else
        output_asm_insn ("lbge\t%l0\t;rev", operands);
    return "";
}
}

static char *
output_84 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("bhs\t%l0\t;rev", operands);
    else
        output_asm_insn ("lbhs\t%l0\t;rev", operands);
    return "";
}
}

static char *
output_85 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("blt\t%l0\t;rev", operands);
    else
        output_asm_insn ("lblt\t%l0\t;rev", operands);
    return "";
}
}

static char *
output_86 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("blo\t%l0\t;rev", operands);
    else
        output_asm_insn ("lblo\t%l0\t;rev", operands);
    return "";
}
}

static char *
output_87 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("bgt\t%l0\t;rev", operands);
    else
        output_asm_insn ("lbgt\t%l0\t;rev", operands);
    return "";
}
}

static char *
output_88 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
    if (TARGET_SHORT_BRANCH)
        output_asm_insn ("bhi\t%l0\t;rev", operands);
    else
        output_asm_insn ("lbhi\t%l0\t;rev", operands);
    return "";
}
}

static char *
output_89 (operands, insn)
     rtx *operands;
     rtx insn;
{

      return "jsr\t%0\t;CALL: (VOIDmode) %0 (%a1 bytes)";
  
}

static char *
output_90 (operands, insn)
     rtx *operands;
     rtx insn;
{

      return "jsr\t%1\t;CALL: R:%0 = %1 (%a2 bytes)";
  
}

char * const insn_template[] =
  {
    "cmp%0\t#0\t;tstsi: R:%0",
    "cmp%0\t#0\t;tsthi: R:%0",
    0,
    "tst\t%0\t;tstsi: MEM:%0",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    "exg\t%1,%0\t;swapsi: R:%1 <-> R:%0",
    "exg\t%1,%0\t;swapqi: R:%1 <-> R:%0",
    "; extendhisi2: %1 -> %0",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    "and%0\t%2\t;andqi: R:%0 &= %2",
    0,
    0,
    "or%0\t%2\t;iorqi: %0 |= %2 ",
    0,
    0,
    "eor%0\t%2\t;xorqi: %0 $= %2 ",
    0,
    0,
    0,
    "coma\t\t;one_cmplsi:\n\tcomb",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    "rol.w %2,%0",
    0,
    0,
    "ror.w %2,%0",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    "nop",
    "ld%0\t%1\t;movsi: %1 -> R:%0 w/ implied test of %2",
    "st%1\t%0\t;movhi: R:%1 -> %0 w/ implied test of %2",
    "st%1\t%0\t;movsi: R:%1 -> %0 w/ redundant move of %3 -> %2",
    "st%1\t%0\t;movhi: R:%1 -> %0 w/ redundant move of %3 -> %2",
  };

char *(*const insn_outfun[])() =
  {
    0,
    0,
    output_2,
    0,
    output_4,
    output_5,
    output_6,
    output_7,
    output_8,
    output_9,
    output_10,
    output_11,
    output_12,
    output_13,
    output_14,
    output_15,
    0,
    0,
    0,
    output_19,
    output_20,
    output_21,
    output_22,
    output_23,
    output_24,
    output_25,
    output_26,
    0,
    output_28,
    output_29,
    output_30,
    output_31,
    0,
    0,
    0,
    0,
    output_36,
    output_37,
    0,
    output_39,
    output_40,
    0,
    output_42,
    output_43,
    0,
    output_45,
    output_46,
    output_47,
    0,
    output_49,
    output_50,
    output_51,
    output_52,
    output_53,
    output_54,
    output_55,
    output_56,
    output_57,
    output_58,
    0,
    output_60,
    output_61,
    0,
    output_63,
    output_64,
    output_65,
    output_66,
    output_67,
    output_68,
    output_69,
    output_70,
    output_71,
    output_72,
    output_73,
    output_74,
    output_75,
    output_76,
    output_77,
    output_78,
    output_79,
    output_80,
    output_81,
    output_82,
    output_83,
    output_84,
    output_85,
    output_86,
    output_87,
    output_88,
    output_89,
    output_90,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
  };

rtx (*const insn_gen_function[]) () =
  {
    gen_tstsi,
    gen_tsthi,
    gen_tstqi,
    0,
    gen_cmpsi,
    gen_cmphi,
    gen_cmpqi,
    0,
    gen_movsi,
    gen_movhi,
    gen_movqi,
    0,
    0,
    0,
    0,
    gen_movstricthi,
    gen_swapsi,
    gen_swapqi,
    gen_extendhisi2,
    gen_extendqisi2,
    gen_extendqihi2,
    gen_zero_extendhisi2,
    gen_zero_extendqihi2,
    gen_addsi3,
    gen_addhi3,
    gen_addqi3,
    gen_subsi3,
    gen_subgen,
    gen_subhi3,
    gen_subqi3,
    gen_mulhi3,
    gen_mulqi3,
    gen_divhi3,
    gen_divqi3,
    gen_modhi3,
    gen_modqi3,
    gen_andsi3,
    gen_andhi3,
    gen_andqi3,
    gen_iorsi3,
    gen_iorhi3,
    gen_iorqi3,
    gen_xorsi3,
    gen_xorhi3,
    gen_xorqi3,
    gen_negsi2,
    gen_neghi2,
    gen_negqi2,
    gen_one_cmplsi2,
    gen_one_cmplhi2,
    gen_one_cmplqi2,
    gen_ashlsi3,
    gen_ashlhi3,
    gen_ashlqi3,
    gen_ashrsi3,
    gen_ashrhi3,
    gen_ashrqi3,
    gen_lshrsi3,
    gen_lshrhi3,
    gen_rotlsi3,
    gen_rotlhi3,
    gen_rotlqi3,
    gen_rotrsi3,
    gen_rotrhi3,
    gen_rotrqi3,
    gen_tablejump,
    gen_indirect_jumpSI,
    gen_indirect_jump,
    gen_jump,
    gen_beq,
    gen_bne,
    gen_bgt,
    gen_bgtu,
    gen_blt,
    gen_bltu,
    gen_bge,
    gen_bgeu,
    gen_ble,
    gen_bleu,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    gen_call,
    gen_call_value,
    gen_call_lib,
    gen_call_lib_hi,
    gen_call_lib_qi,
    gen_nop,
    0,
    0,
    0,
    0,
  };

char *insn_name[] =
  {
    "tstsi",
    "tsthi",
    "tstqi",
    "tstqi+1",
    "cmpsi",
    "cmphi",
    "cmpqi",
    "cmpqi+1",
    "movsi",
    "movhi",
    "movqi",
    "movqi+1",
    "movqi+2",
    "movstricthi-2",
    "movstricthi-1",
    "movstricthi",
    "swapsi",
    "swapqi",
    "extendhisi2",
    "extendqisi2",
    "extendqihi2",
    "zero_extendhisi2",
    "zero_extendqihi2",
    "addsi3",
    "addhi3",
    "addqi3",
    "subsi3",
    "subgen",
    "subhi3",
    "subqi3",
    "mulhi3",
    "mulqi3",
    "divhi3",
    "divqi3",
    "modhi3",
    "modqi3",
    "andsi3",
    "andhi3",
    "andqi3",
    "iorsi3",
    "iorhi3",
    "iorqi3",
    "xorsi3",
    "xorhi3",
    "xorqi3",
    "negsi2",
    "neghi2",
    "negqi2",
    "one_cmplsi2",
    "one_cmplhi2",
    "one_cmplqi2",
    "ashlsi3",
    "ashlhi3",
    "ashlqi3",
    "ashrsi3",
    "ashrhi3",
    "ashrqi3",
    "lshrsi3",
    "lshrhi3",
    "rotlsi3",
    "rotlhi3",
    "rotlqi3",
    "rotrsi3",
    "rotrhi3",
    "rotrqi3",
    "tablejump",
    "indirect_jumpSI",
    "indirect_jump",
    "jump",
    "beq",
    "bne",
    "bgt",
    "bgtu",
    "blt",
    "bltu",
    "bge",
    "bgeu",
    "ble",
    "bleu",
    "bleu+1",
    "bleu+2",
    "bleu+3",
    "bleu+4",
    "bleu+5",
    "call-5",
    "call-4",
    "call-3",
    "call-2",
    "call-1",
    "call",
    "call_value",
    "call_lib",
    "call_lib_hi",
    "call_lib_qi",
    "nop",
    "nop+1",
    "nop+2",
    "nop+3",
    "nop+4",
  };
char **insn_name_ptr = insn_name;

const int insn_n_operands[] =
  {
    1,
    1,
    1,
    1,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    2,
    2,
    2,
    2,
    2,
    2,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    2,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    2,
    3,
    4,
    4,
    4,
    0,
    3,
    3,
    4,
    4,
  };

const int insn_n_dups[] =
  {
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    2,
    2,
    0,
    0,
    0,
    1,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    1,
    1,
    0,
    1,
    1,
    0,
    1,
    1,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
  };

char *const insn_operand_constraint[][MAX_RECOG_OPERANDS] =
  {
    { "r", },
    { "r", },
    { "qm", },
    { "m", },
    { "ad,g,??ad", "g,da,da", },
    { "ad,g,??ad", "g,da,da", },
    { "q,mK", "mK,q", },
    { "=r", "m", },
    { "=r,r,mi", "r,mi,r", },
    { "=r,r,mi", "r,mi,r", },
    { "=q,q,mi", "q,mi,q", },
    { "=q,q,m", "d,m,d", },
    { "=d,d,m", "d,m,d", },
    { "=q,q,m", "d,m,d", },
    { "=d,d,m", "q,m,q", },
    { "d,m,d", "q,q,m", },
    { "+r", "+r", },
    { "+q", "+q", },
    { "g", "g", },
    { "=d", "qmi", },
    { "=d", "qmi", },
    { "=d,m,?m", "qm,q,m", },
    { "=d", "miq", },
    { "=d,=a", "%0,0", "mi,id", },
    { "=d,  =a, =a, !=a", "%0,   a,  0, !a", "mi!r,id, !m, !a", },
    { "=q,m", "%0,0", "mi,I", },
    { "=d,a", "0,0", "mi?r,i", },
    { "=g", "0", "g", },
    { "=d,a", "0,0", "mi?r,i", },
    { "=q", "0", "min", },
    { "=d", "r", "r", },
    { "=q", "%0", "m", },
    { "=d", "0", "a", },
    { "=q,g", "0,0", "qm,g", },
    { "=d", "0", "a", },
    { "=q", "0", "g", },
    { "=d", "%0", "min", },
    { "=d", "%0", "min", },
    { "=q", "%0", "min", },
    { "=d", "%0", "min", },
    { "=d", "%0", "min", },
    { "=q", "%0", "min", },
    { "=d", "%0", "min", },
    { "=d", "%0", "min", },
    { "=q", "%0", "mK", },
    { "=d,a", "0,0", },
    { "=d,a", "0,0", },
    { "=qm", "0", },
    { "=d", "0", },
    { "=d", "0", },
    { "=qm", "0", },
    { "=dm,d", "0,0", "nI,a", },
    { "=dm,d", "0,0", "nI,a", },
    { "=q", "0", "nI", },
    { "=dm,d", "0,0", "nI,a", },
    { "=dm,d", "0,0", "nI,a", },
    { "=qm", "0", "rnI", },
    { "=dm,d", "0,0", "rnI,a", },
    { "=dm,d", "0,0", "rnI,a", },
    { "=dm", "0", "rnI", },
    { "=dm", "0", "rnI", },
    { "=qm", "0", "rnI", },
    { "=dm", "0", "rnI", },
    { "=dm", "0", "rnI", },
    { "=qm", "0", "rnI", },
    { "g", "", },
    { "p", },
    { "p", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "", },
    { "g", "g", },
    { "=g", "g", "g", },
    { "", "", "", "", },
    { "", "", "", "", },
    { "", "", "", "", },
    { 0 },
    { "=r", "m", "r", },
    { "=m", "r", "g", },
    { "=m", "r", "=r", "m", },
    { "=m", "r", "=r", "m", },
  };

const enum machine_mode insn_operand_mode[][MAX_RECOG_OPERANDS] =
  {
    { SImode, },
    { HImode, },
    { QImode, },
    { SImode, },
    { SImode, SImode, },
    { HImode, HImode, },
    { QImode, QImode, },
    { SImode, SImode, },
    { SImode, SImode, },
    { HImode, HImode, },
    { QImode, QImode, },
    { QImode, SImode, },
    { QImode, SImode, },
    { QImode, HImode, },
    { QImode, QImode, },
    { SImode, HImode, },
    { SImode, SImode, },
    { QImode, QImode, },
    { SImode, HImode, },
    { SImode, QImode, },
    { HImode, QImode, },
    { SImode, HImode, },
    { HImode, QImode, },
    { SImode, SImode, SImode, },
    { HImode, HImode, HImode, },
    { QImode, QImode, QImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { HImode, HImode, HImode, },
    { QImode, QImode, QImode, },
    { HImode, HImode, HImode, },
    { QImode, QImode, QImode, },
    { HImode, HImode, HImode, },
    { QImode, QImode, QImode, },
    { HImode, HImode, HImode, },
    { QImode, QImode, QImode, },
    { SImode, SImode, SImode, },
    { HImode, HImode, HImode, },
    { QImode, QImode, QImode, },
    { SImode, SImode, SImode, },
    { HImode, HImode, HImode, },
    { QImode, QImode, QImode, },
    { SImode, SImode, SImode, },
    { HImode, HImode, HImode, },
    { QImode, QImode, QImode, },
    { SImode, SImode, },
    { HImode, HImode, },
    { QImode, QImode, },
    { SImode, SImode, },
    { HImode, HImode, },
    { QImode, QImode, },
    { SImode, SImode, SImode, },
    { HImode, HImode, HImode, },
    { QImode, QImode, QImode, },
    { SImode, SImode, SImode, },
    { HImode, HImode, HImode, },
    { QImode, QImode, QImode, },
    { SImode, SImode, SImode, },
    { HImode, HImode, HImode, },
    { SImode, SImode, SImode, },
    { HImode, HImode, HImode, },
    { QImode, QImode, HImode, },
    { SImode, SImode, SImode, },
    { HImode, HImode, HImode, },
    { QImode, QImode, QImode, },
    { HImode, VOIDmode, },
    { SImode, },
    { HImode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { VOIDmode, },
    { HImode, SImode, },
    { VOIDmode, HImode, SImode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
  };

const char insn_operand_strict_low[][MAX_RECOG_OPERANDS] =
  {
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0 },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
  };

extern int register_operand ();
extern int byte_operand ();
extern int memory_operand ();
extern int general_operand ();
extern int byte_reg_operand ();
extern int data_reg_operand ();
extern int address_operand ();
extern int nonmemory_operand ();

int (*const insn_operand_predicate[][MAX_RECOG_OPERANDS])() =
  {
    { register_operand, },
    { register_operand, },
    { byte_operand, },
    { memory_operand, },
    { general_operand, general_operand, },
    { general_operand, general_operand, },
    { byte_operand, byte_operand, },
    { general_operand, memory_operand, },
    { general_operand, general_operand, },
    { general_operand, general_operand, },
    { byte_operand, byte_operand, },
    { byte_operand, general_operand, },
    { byte_operand, general_operand, },
    { byte_operand, general_operand, },
    { byte_operand, byte_operand, },
    { general_operand, byte_operand, },
    { register_operand, register_operand, },
    { byte_reg_operand, byte_reg_operand, },
    { general_operand, general_operand, },
    { data_reg_operand, byte_operand, },
    { data_reg_operand, byte_operand, },
    { general_operand, general_operand, },
    { general_operand, general_operand, },
    { register_operand, register_operand, general_operand, },
    { register_operand, register_operand, general_operand, },
    { byte_operand, byte_operand, general_operand, },
    { register_operand, register_operand, general_operand, },
    { general_operand, general_operand, general_operand, },
    { register_operand, register_operand, general_operand, },
    { register_operand, register_operand, address_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, byte_operand, },
    { data_reg_operand, data_reg_operand, register_operand, },
    { byte_reg_operand, byte_reg_operand, byte_operand, },
    { data_reg_operand, data_reg_operand, register_operand, },
    { byte_reg_operand, byte_reg_operand, byte_operand, },
    { data_reg_operand, data_reg_operand, address_operand, },
    { data_reg_operand, data_reg_operand, general_operand, },
    { byte_reg_operand, byte_reg_operand, general_operand, },
    { data_reg_operand, data_reg_operand, address_operand, },
    { data_reg_operand, data_reg_operand, general_operand, },
    { byte_reg_operand, byte_reg_operand, general_operand, },
    { data_reg_operand, data_reg_operand, address_operand, },
    { data_reg_operand, data_reg_operand, address_operand, },
    { byte_reg_operand, byte_reg_operand, byte_operand, },
    { register_operand, register_operand, },
    { general_operand, general_operand, },
    { byte_operand, byte_operand, },
    { data_reg_operand, data_reg_operand, },
    { general_operand, general_operand, },
    { byte_operand, byte_operand, },
    { general_operand, general_operand, nonmemory_operand, },
    { general_operand, general_operand, nonmemory_operand, },
    { byte_reg_operand, byte_reg_operand, nonmemory_operand, },
    { general_operand, general_operand, nonmemory_operand, },
    { general_operand, general_operand, nonmemory_operand, },
    { byte_operand, general_operand, nonmemory_operand, },
    { general_operand, general_operand, nonmemory_operand, },
    { general_operand, general_operand, nonmemory_operand, },
    { general_operand, general_operand, nonmemory_operand, },
    { general_operand, general_operand, nonmemory_operand, },
    { byte_operand, byte_operand, nonmemory_operand, },
    { general_operand, general_operand, nonmemory_operand, },
    { byte_operand, byte_operand, nonmemory_operand, },
    { byte_operand, byte_operand, nonmemory_operand, },
    { general_operand, 0, },
    { address_operand, },
    { address_operand, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { 0, },
    { general_operand, general_operand, },
    { 0, general_operand, general_operand, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0 },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, 0, },
  };

const int insn_n_alternatives[] =
  {
    1,
    1,
    1,
    1,
    3,
    3,
    2,
    1,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    1,
    1,
    1,
    1,
    1,
    3,
    1,
    2,
    4,
    2,
    2,
    1,
    2,
    1,
    1,
    1,
    1,
    2,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    2,
    2,
    1,
    1,
    1,
    1,
    2,
    2,
    1,
    2,
    2,
    1,
    2,
    2,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    1,
    1,
    0,
    0,
    0,
    0,
    1,
    1,
    1,
    1,
  };
