; this is the file that
; has routines to draw the handwritten CHRIS

; actually this is only a rip from
; moon lander
; wasn't much that needed changing...

; hm - no comments

VIA__a = 0HD001
VIA__b = 0HD000
VIA_acntl = 0HD00B
VIA_shift = 0HD00A

        .area __bss
;c_l_buf:  .blkb  300
cp_count: .blkb   2
cl_buf:   .blkb   400

        .area __code
        .globl  _draw_mcl_
_draw_mcl_:
        ldu      #cl_buf               ; load to pointer
                 ldd     #0H1881       ; load D with VIA pokes
                 stb     VIA__b        ; poke 0H81 to port B
                                       ; disable MUX
                                       ; disable ~RAMP
                 sta     VIA_acntl     ; poke 0H18 to AUX
                                       ; shift mode 4
                                       ; PB7 not timer controlled
                                       ; PB7 is ~RAMP
                 bra     n_u_round     ; jump to entry of loop
x_uli:
                 stb     VIA__b        ; MUX disable, ~RAMP enable
                 sta     VIA_shift     ; poke the enable byte (A) found to
                                       ; shift, that enables/disables ~BLANK
x_uloop:
                 lda     ,u+           ; load next X_update value
                 beq     finish_x      ; if zero, we are done with this
                                       ; X_update
                 sta     VIA__a        ; otherwise put the found value to
                                       ; DAC and thus to X integration
                 bra     x_uloop       ; go on, look if another X_update
                                       ; value is there...
finish_x:
                 ldb     #0H81         ; load value for ramp off, MUX off
                 stb     VIA__b        ; poke 0H81, ramp off, MUX off

                 nop                   ; these NOP's seem to be neccessary
                 nop                   ; since the delay between VIA and
                 nop                   ; integration hardware
                 nop                   ; otherwise, there is a space
                                       ; between Y_updates...    Chris

                 sta     VIA_shift     ; A == %00000000
n_u_round:
                 lda     ,u+               ; load next Y_update
                 beq     done_cl       ; go to done if 0
                 sta     VIA__a        ; poke to DAC
                 decb                  ; B now 0H80
                 stb     VIA__b        ; enable MUX, that means put
                                       ; DAC to Y integrator S/H
                 ldd     ,u++          ; A=VIDEO_enable, B=X_update
                 inc     VIA__b        ; MUX off, only X on DAC now
                 stb     VIA__a        ; store B (X_update) to DAC
                 ldb     #0H01         ; load poke for MUX disable,
                                       ; ~RAMP enable
                 bra     x_uli; goto x update loop
done_cl:
                 lda     #0H98         ; load AUX setting
                 sta     VIA_acntl     ; restore usual AUX setting
                                       ; (enable PB7 timer, SHIFT mode 4)
;        ldd     #0H0102                ; this cleans up the joystick wobble effect
;        clr     VIA__a                 ; clear D/A register
;        stb     VIA__b                 ; mux=2, enable mux
;        clr     VIA__b                 ; mux=0, enable mux
;        sta     VIA__b                 ; disable mux
                 rts                   ; and out of here
        .globl  _cp_chr_
; counter in d
_cp_chr_:
        std      cp_count              ; store thisas copy length
        ldu      #c_text               ; load from pointer
        ldx      #cl_buf               ; load to pointer
n_cl:
        lda      ,u+                   ; this is the first byte
        sta      ,x+                   ; y or 0
        beq      ic2_done              ; if zero... we are done
        lda      ,u+                   ; mode byte
        sta      ,x+                   ; just copy  it
nextxb:
        lda      ,u+                   ; x or zero
        sta      ,x+                   ; copy it
        beq      n_cl                  ; if zero... this 'line' is done
        ldd      cp_count              ; load counter
        subd     #1                    ; reduce by one x coordinate
        std      cp_count              ; re<store> it
        bne      nextxb                ; if not zero... go on copying
        std      ,x                    ; otherwise finnish of with 0,0
ic2_done:
        rts                            ; bye

;***************************************************************************
;                   DB  Y_update, VIDEO_enable, X_update, Xupdate,... ,0
;                   DB  Y_update, VIDEO_enable, X_update, Xupdate,... ,0
;                   DB  ...
;                   DB  0       ; 0 end of update list
c_text:
                 ; C
                 .byte  0H10,  0Hff, -0H03, -0H06, -0H0c, -0H14,  0H00
                 .byte -0H10,  0Hff, -0H18, -0H0c, -0H08, -0H04, -0H02, -0H02, -0H01,  0H00
                 .byte -0H10,  0Hff,  0H01,  0H02,  0H02,  0H04 , 0H08,  0H0c,  0H10,  0H18
                 .byte              0H20,  0H00
                 .byte  0H10,  0Hff,  0H20,  0H18,  0H10,  0H0c,  0H08,  0H08,  0H04,  0H02
                 .byte              0H02, -0H02  -0H02, -0H04, -0H04, -0H08, -0H0c, -0H0c
                 .byte              0H00

                 ; h
                 .byte -0H10,  0Hff, -0H18, -0H0c, -0H08, -0H04, -0H02, -0H02, -0H01,  0H00
                 .byte -0H10,  0Hff, -0H01, -0H01, -0H01, -0H01, -0H01, -0H01, -0H01,  0H00
                 .byte  0H10,  0Hff,  0H01,  0H02,  0H03,  0H04,  0H05,  0H07,  0H0a,  0H00
                 .byte  0H04,  0Hff,  0H04,  0H06,  0H08,  0H0c,  0H00
                 .byte -0H04,  0Hff,  0H0c,  0H08,  0H06,  0H04,  0H00
                 .byte -0H10,  0Hff,  0H07,  0H05,  0H01,  0H01,  0H01,  0H01,  0H01,  0H00
                 .byte -0H04,  0Hff,  0H02,  0H04,  0H06,  0H08,  0H00

                 ;r
                 .byte  0H04,  0Hff,  0H08,  0H06,  0H04,  0H02,  0H00
                 .byte  0H10,  0Hff,  0H01,  0H01,  0H01,  0H01,  0H05,  0H07,  0H0a,  0H00
                 .byte  0H04,  0Hff,  0H04,  0H06,  0H08,  0H0c,  0H00
                 .byte -0H04,  0Hff,  0H0c,  0H08,  0H06,  0H04,  0H00
                 .byte -0H10,  0Hff,  0H07,  0H05,  0H01,  0H01,  0H01,  0H01,  0H01
                 .byte              0H01,  0H00
                 .byte  0H1c,  0Hff,  0H01,  0H01,  0H01,  0H01,  0H01,  0H00
                 .byte -0H0c,  0Hff,  0H05,  0H0a,  0H15,  0H00

                 ; i
                 .byte  0H0c,  0Hff,  0H15,  0H0a,  0H05,  0H00
                 .byte  0H0c,  0H00,  0H01,  0H01,  0H00
                 .byte  0H0c,  0H01,  0H01,  0H00
                 .byte -0H0c,  0H00, -0H01, -0H01, -0H01,  0H00
                 .byte -0H10,  0Hff,  0H01,  0H01,  0H01,  0H01,  0H01,  0H01,  0H01,  0H01
                 .byte              0H00
                 .byte -0H04,  0Hff,  0H02,  0H04,  0H06,  0H08,  0H00

                 ; s
                 .byte  0H04,  0Hff,  0H08,  0H06,  0H04,  0H02,  0H00
                 .byte  0H10,  0Hff,  0H06,  0H06,  0H06,  0H06,  0H06,  0H06,  0H06,  0H06
                 .byte              0H00
                 .byte -0H0c,  0Hff,  0H05,  0H0a,  0H15,  0H00
                 .byte -0H06,  0Hff,  0H0c,  0H08,  0H07,  0H05,  0H03,  0H00
                 .byte -0H0e,  0Hff, -0H01, -0H02, -0H03, -0H08, -0H0a, -0H0c,  0H00

                 .byte 0
