#define CUBE_STRENGTH 250

struct Line3d cubeM[] =
{
 {0, CUBE_STRENGTH/2, _N_1_N}, // figured that out by trial and error!
 {255, CUBE_STRENGTH, _1_0_0},
 {255, CUBE_STRENGTH, _0_1_0},
 {255, CUBE_STRENGTH, _N_0_0},
 {255, CUBE_STRENGTH, _0_N_0},

 {255, CUBE_STRENGTH, _0_0_1},

 {255, CUBE_STRENGTH, _1_0_0},
 {255, CUBE_STRENGTH, _0_1_0},
 {255, CUBE_STRENGTH, _N_0_0},
 {255, CUBE_STRENGTH, _0_N_0},

 {  0, CUBE_STRENGTH, _1_0_0},
 {255, CUBE_STRENGTH, _0_0_N},

 {  0, CUBE_STRENGTH, _0_1_0},
 {255, CUBE_STRENGTH, _0_0_1},
 {  0, CUBE_STRENGTH, _N_0_0},
 {255, CUBE_STRENGTH, _0_0_N},

 {  1, 0, _0_0_N}
};

init3dCube()
{
 cosx = cosinus3d[angle_x];
 sinx = sinus3d[angle_x];
 cosy = cosinus3d[angle_y];
 siny = sinus3d[angle_y];
 cosz = cosinus3d[angle_z];
 sinz = sinus3d[angle_z];

 // per single vector about 250 - 300 cycles
 //...  all used vector combinations

 // set to init for Mcube!
 INIT_1_0_0_A;
 INIT_0_1_0_A;
 INIT_0_0_1_A;
 INIT_N_1_N;
}

void cube_demo()
{
  angle_x = 0;
  angle_y = 0;
  angle_z = 0;
  ym_init(&BITTLOAD_data);

  while (true)
  {
    start_one_vectrex_round();  /* start vectrex round */
    intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

    init3dCube();
    zero_beam();
    move_to(0, 0);
    draw_3ds(cubeM);

    if (joystick1_button4)
    {
      angle_x++;
      if (angle_x == 64) angle_x = 0;
    }
    if (joystick1_button3)
    {
      angle_y++;
      if (angle_y == 64) angle_y = 0;
    }
    if (joystick1_button2)
    {
      angle_z++;
      if (angle_z == 64) angle_z = 0;
    }
    if (joystick1_button1)
    {
      break;
    }
    read_buttons();
  }
}

