#define PYRAMID_STRENGTH 10

// using scale to double line saves cycles
// in this case about 150
struct Line3d pyramid[] =
{
   {0, 2*PYRAMID_STRENGTH, _0_0_N},
   {0, 2*PYRAMID_STRENGTH, _N_0_0},
   {0, 1*PYRAMID_STRENGTH, _0_1_0},

   {255, 4*PYRAMID_STRENGTH, _1_0_0},
   {255, 4*PYRAMID_STRENGTH, _0_0_1},
   {255, 4*PYRAMID_STRENGTH, _N_0_0},
   {255, 4*PYRAMID_STRENGTH, _0_0_N},

   {255, 2*PYRAMID_STRENGTH, _1_1_1},

   {255, 2*PYRAMID_STRENGTH, _1_N_1},
   {  0, 2*PYRAMID_STRENGTH, _N_1_N},
   {255, 2*PYRAMID_STRENGTH, _N_N_1},
   {  0, 2*PYRAMID_STRENGTH, _1_1_N},
   {255, 2*PYRAMID_STRENGTH, _1_N_N},

   {  1, 0, _0_0_N}
};

init3dpyramid()
{
 cosx = cosinus3d[angle_x];
 sinx = sinus3d[angle_x];
 cosy = cosinus3d[angle_y];
 siny = sinus3d[angle_y];
 cosz = cosinus3d[angle_z];
 sinz = sinus3d[angle_z];

 // per single vector about 250 - 300 cycles
 //...  all used vector combinations

 // set to init for pyramid!
 INIT_1_0_0_A;
 INIT_0_0_1_A;
 INIT_1_1_1;
 INIT_N_1_1_I;
 INIT_1_1_N_A;
 INIT_1_N_1_A;

 INIT_0_1_0;

}

void pyramid_demo()
{
  unsigned short save_x;
  unsigned short save_y;
  unsigned short save_z;
  angle_x = 0;
  angle_y = 0;
  angle_z = 0;
  ym_init(&BITTLOAD_data);

  while (true)
  {
    start_one_vectrex_round();  /* start vectrex round */
    intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

    save_x = angle_x;
    save_y = angle_y;
    save_z = angle_z;

    init3dpyramid();
    zero_beam();
    set_scale(200);
    move_to(-90, 0);
    draw_3ds(pyramid);

    angle_x++;if (angle_x == 64) angle_x = 0;
    angle_y++;if (angle_y == 64) angle_y = 0;
    angle_z++;if (angle_z == 64) angle_z = 0;
    init3dpyramid();
    zero_beam();
    set_scale(200);
    move_to(-60, 0);
    draw_3ds(pyramid);

    angle_x++;if (angle_x == 64) angle_x = 0;
    angle_y++;if (angle_y == 64) angle_y = 0;
    angle_z++;if (angle_z == 64) angle_z = 0;
    init3dpyramid();
    zero_beam();
    set_scale(200);
    move_to(-30, 0);
    draw_3ds(pyramid);

    angle_x++;if (angle_x == 64) angle_x = 0;
    angle_y++;if (angle_y == 64) angle_y = 0;
    angle_z++;if (angle_z == 64) angle_z = 0;
    init3dpyramid();
    zero_beam();
    set_scale(200);
    move_to(0, 0);
    draw_3ds(pyramid);

    angle_x++;if (angle_x == 64) angle_x = 0;
    angle_y++;if (angle_y == 64) angle_y = 0;
    angle_z++;if (angle_z == 64) angle_z = 0;
    init3dpyramid();
    zero_beam();
    set_scale(200);
    move_to(30, 0);
    draw_3ds(pyramid);

    angle_x++;if (angle_x == 64) angle_x = 0;
    angle_y++;if (angle_y == 64) angle_y = 0;
    angle_z++;if (angle_z == 64) angle_z = 0;
    init3dpyramid();
    zero_beam();
    set_scale(200);
    move_to(60, 0);
    draw_3ds(pyramid);

    angle_x++;if (angle_x == 64) angle_x = 0;
    angle_y++;if (angle_y == 64) angle_y = 0;
    angle_z++;if (angle_z == 64) angle_z = 0;
    init3dpyramid();
    zero_beam();
    set_scale(200);
    move_to(90, 0);
    draw_3ds(pyramid);

    angle_x = save_x;
    angle_y = save_y;
    angle_z = save_z;
    if (joystick1_button4)
    {
      angle_x++;
      if (angle_x == 64) angle_x = 0;
    }
    if (joystick1_button3)
    {
      angle_y++;
      if (angle_y == 64) angle_y = 0;
    }
    if (joystick1_button2)
    {
      angle_z++;
      if (angle_z == 64) angle_z = 0;
    }
    if (joystick1_button1)
    {
      break;
    }
    read_buttons();
  }
}

void p2yramid_demo()
{
  angle_x = 0;
  angle_y = 0;
  angle_z = 0;
  ym_init(&BITTLOAD_data);

  while (true)
  {
    start_one_vectrex_round();  /* start vectrex round */
    intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

    init3dpyramid();

    zero_beam();
    set_scale(200);
    move_to(-90, -30);
    draw_3ds(pyramid);

    zero_beam();
    set_scale(200);
    move_to(-60, -30);
    draw_3ds(pyramid);

    zero_beam();
    set_scale(200);
    move_to(-30, -30);
    draw_3ds(pyramid);

    zero_beam();
    set_scale(200);
    move_to(0, -30);
    draw_3ds(pyramid);

    zero_beam();
    set_scale(200);
    move_to(30, -30);
    draw_3ds(pyramid);

    zero_beam();
    set_scale(200);
    move_to(60, -30);
    draw_3ds(pyramid);

    zero_beam();
    set_scale(200);
    move_to(90, -30);
    draw_3ds(pyramid);

    zero_beam();
    set_scale(200);
    move_to(-90, 0);
    draw_3ds(pyramid);

    zero_beam();
    set_scale(200);
    move_to(-60, 0);
    draw_3ds(pyramid);

    zero_beam();
    set_scale(200);
    move_to(-30, 0);
    draw_3ds(pyramid);

    zero_beam();
    set_scale(200);
    move_to(0, 0);
    draw_3ds(pyramid);

    zero_beam();
    set_scale(200);
    move_to(30, 0);
    draw_3ds(pyramid);

    zero_beam();
    set_scale(200);
    move_to(60, 0);
    draw_3ds(pyramid);

    zero_beam();
    set_scale(200);
    move_to(90, 0);
    draw_3ds(pyramid);

    if (joystick1_button4)
    {
      angle_x++;
      if (angle_x == 64) angle_x = 0;
    }
    if (joystick1_button3)
    {
      angle_y++;
      if (angle_y == 64) angle_y = 0;
    }
    if (joystick1_button2)
    {
      angle_z++;
      if (angle_z == 64) angle_z = 0;
    }
    if (joystick1_button1)
    {
      break;
    }
    read_buttons();
  }
}

