#define RIP_BIRD_STRENGTH 40
#define VEC_BLOWUP 24

const signed char rip[] =
{
                 39,
                 5*VEC_BLOWUP,  0*VEC_BLOWUP,
                 0*VEC_BLOWUP,  1*VEC_BLOWUP,
                 1*VEC_BLOWUP, -1*VEC_BLOWUP,
                 2*VEC_BLOWUP,  2*VEC_BLOWUP,
                 0*VEC_BLOWUP,  2*VEC_BLOWUP,
                -1*VEC_BLOWUP,  0*VEC_BLOWUP,
                 1*VEC_BLOWUP,  1*VEC_BLOWUP,
                 0*VEC_BLOWUP,  3*VEC_BLOWUP,
                -2*VEC_BLOWUP,  2*VEC_BLOWUP,
                -1*VEC_BLOWUP, -1*VEC_BLOWUP,
                 0*VEC_BLOWUP,  1*VEC_BLOWUP,
                -3*VEC_BLOWUP,  0*VEC_BLOWUP,
                 1*VEC_BLOWUP, -1*VEC_BLOWUP,
                -2*VEC_BLOWUP,  1*VEC_BLOWUP,
                -5*VEC_BLOWUP,  0*VEC_BLOWUP,
                -2*VEC_BLOWUP,  0*VEC_BLOWUP,
                 0*VEC_BLOWUP, -5*VEC_BLOWUP,
                 0*VEC_BLOWUP, -5*VEC_BLOWUP,
                 5*VEC_BLOWUP,  0*VEC_BLOWUP,
                 1*VEC_BLOWUP,  2*VEC_BLOWUP,
                 0*VEC_BLOWUP,  3*VEC_BLOWUP,
                 0*VEC_BLOWUP,  4*VEC_BLOWUP,
                 1*VEC_BLOWUP, -1*VEC_BLOWUP,
                 0*VEC_BLOWUP, -2*VEC_BLOWUP,
                 2*VEC_BLOWUP,  0*VEC_BLOWUP,
                 0*VEC_BLOWUP,  1*VEC_BLOWUP,
                 1*VEC_BLOWUP,  1*VEC_BLOWUP,
                 1*VEC_BLOWUP, -1*VEC_BLOWUP,
                 0*VEC_BLOWUP, -1*VEC_BLOWUP,
                -4*VEC_BLOWUP,  0*VEC_BLOWUP,
                 0*VEC_BLOWUP, -1*VEC_BLOWUP,
                 4*VEC_BLOWUP,  0*VEC_BLOWUP,
                -4*VEC_BLOWUP,  0*VEC_BLOWUP,
                 0*VEC_BLOWUP, -1*VEC_BLOWUP,
                 2*VEC_BLOWUP, -1*VEC_BLOWUP,
                 1*VEC_BLOWUP,  1*VEC_BLOWUP,
                 1*VEC_BLOWUP, -1*VEC_BLOWUP,
                 0*VEC_BLOWUP, -1*VEC_BLOWUP,
                -4*VEC_BLOWUP,  0*VEC_BLOWUP,
                -1*VEC_BLOWUP, -2*VEC_BLOWUP
};

initRip()
{
 cosx = cosinus3d[angle_x];
 sinx = sinus3d[angle_x];
 cosy = cosinus3d[angle_y];
 siny = sinus3d[angle_y];
 cosz = cosinus3d[angle_z];
 sinz = sinus3d[angle_z];

 // per single vector about 250 - 300 cycles
 //...  all used vector combinations
 // set to init for birdy
 INIT_0_1_0_A;
 INIT_1_N_0_A;
 INIT_1_0_0_A;
 INIT_1_1_0_A;
 INIT_0_0_1_A;
}

void rip_demo()
{
  signed char delta_x;
  signed char delta_y;
  unsigned short counter;
  unsigned short animCounter;
  unsigned short animSecCounter;
  unsigned short angleSecCounter;

  angle_x = 9;
  angle_y = 6;
  angle_z = 16;
  ym_init(&JH3_data);

  delta_x = 0;
  delta_y = 0;
  counter = 0;

  animCounter = 0;
  animSecCounter = 0;
  angleSecCounter = 0;

  while (true)
  {
    if (ym_cdata == 0)
    {
     ym_init(&JH3_data);
    }
    start_one_vectrex_round();  /* start vectrex round */
    intensity(MAX_BRIGHTNESS);  /* set intensity of vector beam... */

    initRip();
    zero_beam();
    move_to(-23, -50);
    set_scale(40);
    draw_vector_list(rip); // draw the RIP

    zero_beam();
    delta_x = cosinus[counter]; // position of the bird
    delta_y = sinus[counter];
    zero_beam();
    set_scale(90); // move there
    move_to(delta_x, 63 + (delta_y>>1)); // but no full circle, divide y / 2
    delta_y = delta_y >> 3; // -16 - +16
    delta_y = delta_y + 16; // 0  -  32
    set_scale(RIP_BIRD_STRENGTH - delta_y); // set bird size!
    draw_3d(birdy[animCounter]); // and draw it
    zero_beam();

    counter++;
    if (counter == 128) // position is old trih.g - 128
    {
     counter = 0;
    }
    angleSecCounter++;
    if (angleSecCounter == 2) // increase every second because of circle width is 128 not 64
    {
      angleSecCounter = 0;
      angle_y++;              // the angle the bird is 'viewing'
      if (angle_y == 64) angle_y = 0;
    }

    animSecCounter++;         // bird animation stuff
    if (animSecCounter == 10)
    {
     animSecCounter = 0;
     animCounter++;
     if (animCounter == 4)
     {
      animCounter = 0;
     }
    }

    if (joystick1_button1)
    {
      break;
    }
    read_buttons();
  }
}
