#ifndef _MAN_MAN_H_
#define _MAN_MAN_H_



#define MAN_SCALE 5
#define MAN_SIZE (25)

#define MAN_ANIM_MAX 7

const signed char manRight1[]=
{
                 16,
                  0 * MAN_SIZE, -1 * MAN_SIZE,
                  2 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE,  2 * MAN_SIZE,
                 -2 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -1 * MAN_SIZE,
                 -1 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -1 * MAN_SIZE,
                 -5 * MAN_SIZE,  0 * MAN_SIZE,
                 -5 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE,  3 * MAN_SIZE,
                  1 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -1 * MAN_SIZE,
                  5 * MAN_SIZE,  0 * MAN_SIZE,
                  4 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -1 * MAN_SIZE,
                 -3 * MAN_SIZE,  0 * MAN_SIZE,
                 -2 * MAN_SIZE,  0 * MAN_SIZE
};

const signed char manRight2[]=
{
                  24,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   2 * MAN_SIZE,
                  -2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -5 * MAN_SIZE,   0 * MAN_SIZE,
                  -2 * MAN_SIZE,  -1 * MAN_SIZE,
                  -2 * MAN_SIZE,  -1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   3 * MAN_SIZE,   1 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   2 * MAN_SIZE,  -1 * MAN_SIZE,
                   4 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -3 * MAN_SIZE,  -1 * MAN_SIZE,
                  -1 * MAN_SIZE,   2 * MAN_SIZE
};

const signed char manRight3[]=
{
                  25,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   2 * MAN_SIZE,
                  -2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -5 * MAN_SIZE,   0 * MAN_SIZE,
                  -2 * MAN_SIZE,  -1 * MAN_SIZE,
                  -2 * MAN_SIZE,  -2 * MAN_SIZE,
                  -1 * MAN_SIZE,   1 * MAN_SIZE,
                   0 * MAN_SIZE,   2 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   3 * MAN_SIZE,   2 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   3 * MAN_SIZE,  -1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   4 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -3 * MAN_SIZE,  -3 * MAN_SIZE,
                  -2 * MAN_SIZE,   3 * MAN_SIZE
};

const signed char manRight4[]=
{
                  23,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   2 * MAN_SIZE,
                  -2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -5 * MAN_SIZE,   0 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                  -3 * MAN_SIZE,  -3 * MAN_SIZE,
                  -1 * MAN_SIZE,   2 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   2 * MAN_SIZE,   2 * MAN_SIZE,
                  -2 * MAN_SIZE,  -1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   3 * MAN_SIZE,   0 * MAN_SIZE,
                   4 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -3 * MAN_SIZE,  -2 * MAN_SIZE,
                  -2 * MAN_SIZE,   2 * MAN_SIZE
};

const signed char manRight5[]=
{
                  24,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   0 * MAN_SIZE,   0 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   2 * MAN_SIZE,
                  -2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -2 * MAN_SIZE,  -1 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   1 * MAN_SIZE,   1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   5 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -4 * MAN_SIZE,   0 * MAN_SIZE,
                  -1 * MAN_SIZE,   2 * MAN_SIZE
};

const signed char manRight6[]=
{
                  24,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -2 * MAN_SIZE,
                  -2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -3 * MAN_SIZE,  -2 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   2 * MAN_SIZE,   2 * MAN_SIZE,
                  -2 * MAN_SIZE,  -1 * MAN_SIZE,
                   0 * MAN_SIZE,   3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   2 * MAN_SIZE,  -1 * MAN_SIZE,
                   3 * MAN_SIZE,   0 * MAN_SIZE,
                   3 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -4 * MAN_SIZE,   1 * MAN_SIZE,
                  -1 * MAN_SIZE,   2 * MAN_SIZE
};


const signed char manRight7[]=
{
                  24,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -2 * MAN_SIZE,
                  -2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -2 * MAN_SIZE,  -1 * MAN_SIZE,
                  -1 * MAN_SIZE,  -1 * MAN_SIZE,
                  -1 * MAN_SIZE,   3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   3 * MAN_SIZE,   1 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -1 * MAN_SIZE,  -1 * MAN_SIZE,
                   0 * MAN_SIZE,   3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   3 * MAN_SIZE,   0 * MAN_SIZE,
                   3 * MAN_SIZE,  -1 * MAN_SIZE,
                   3 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -4 * MAN_SIZE,   2 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE
};

const signed char manRight8[]=
{
                 23,
                  0 * MAN_SIZE, -1 * MAN_SIZE,
                  2 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE,  2 * MAN_SIZE,
                 -2 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -1 * MAN_SIZE,
                 -1 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -1 * MAN_SIZE,
                 -5 * MAN_SIZE,  0 * MAN_SIZE,
                 -5 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE,  3 * MAN_SIZE,
                  1 * MAN_SIZE, -3 * MAN_SIZE,
                  2 * MAN_SIZE,  1 * MAN_SIZE,
                  2 * MAN_SIZE, -1 * MAN_SIZE,
                 -4 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE,  2 * MAN_SIZE,
                  0 * MAN_SIZE,  1 * MAN_SIZE,
                  1 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -1 * MAN_SIZE,
                  2 * MAN_SIZE,  0 * MAN_SIZE,
                  2 * MAN_SIZE,  0 * MAN_SIZE,
                  4 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -1 * MAN_SIZE,
                 -4 * MAN_SIZE,  0 * MAN_SIZE,
                 -1 * MAN_SIZE,  2 * MAN_SIZE


};

const signed char * manRight[MAN_ANIM_MAX]=
{
  manRight2,
  manRight3,
  manRight4,
  manRight5,
  manRight6,
  manRight7,
  manRight8
};

const signed char manLeft1[]=
{
                 16,
                  0 * MAN_SIZE,  1 * MAN_SIZE,
                  2 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -2 * MAN_SIZE,
                 -2 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE,  1 * MAN_SIZE,
                 -1 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE,  1 * MAN_SIZE,
                 -5 * MAN_SIZE,  0 * MAN_SIZE,
                 -5 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -3 * MAN_SIZE,
                  1 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE,  1 * MAN_SIZE,
                  5 * MAN_SIZE,  0 * MAN_SIZE,
                  4 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE,  1 * MAN_SIZE,
                 -3 * MAN_SIZE,  0 * MAN_SIZE,
                 -2 * MAN_SIZE,  0 * MAN_SIZE
};

const signed char manLeft2[]=
{
                  24,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -2 * MAN_SIZE,
                  -2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -5 * MAN_SIZE,   0 * MAN_SIZE,
                  -2 * MAN_SIZE,   1 * MAN_SIZE,
                  -2 * MAN_SIZE,   1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   3 * MAN_SIZE,  -1 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   2 * MAN_SIZE,   1 * MAN_SIZE,
                   4 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -3 * MAN_SIZE,   1 * MAN_SIZE,
                  -1 * MAN_SIZE,  -2 * MAN_SIZE
};

const signed char manLeft3[]=
{
                  25,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -2 * MAN_SIZE,
                  -2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -5 * MAN_SIZE,   0 * MAN_SIZE,
                  -2 * MAN_SIZE,   1 * MAN_SIZE,
                  -2 * MAN_SIZE,   2 * MAN_SIZE,
                  -1 * MAN_SIZE,  -1 * MAN_SIZE,
                   0 * MAN_SIZE,  -2 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   3 * MAN_SIZE,  -2 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   3 * MAN_SIZE,   1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   4 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -3 * MAN_SIZE,   3 * MAN_SIZE,
                  -2 * MAN_SIZE,  -3 * MAN_SIZE
};

const signed char manLeft4[]=
{
                  23,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -2 * MAN_SIZE,
                  -2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -5 * MAN_SIZE,   0 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                  -3 * MAN_SIZE,   3 * MAN_SIZE,
                  -1 * MAN_SIZE,  -2 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   2 * MAN_SIZE,  -2 * MAN_SIZE,
                  -2 * MAN_SIZE,   1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   3 * MAN_SIZE,   0 * MAN_SIZE,
                   4 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -3 * MAN_SIZE,   2 * MAN_SIZE,
                  -2 * MAN_SIZE,  -2 * MAN_SIZE
};

const signed char manLeft5[]=
{
                  24,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   0 * MAN_SIZE,   0 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -2 * MAN_SIZE,
                  -2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -2 * MAN_SIZE,   1 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   1 * MAN_SIZE,  -1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   5 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -4 * MAN_SIZE,   0 * MAN_SIZE,
                  -1 * MAN_SIZE,  -2 * MAN_SIZE
};

const signed char manLeft6[]=
{
                  24,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   2 * MAN_SIZE,
                  -2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -3 * MAN_SIZE,   2 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   2 * MAN_SIZE,  -2 * MAN_SIZE,
                  -2 * MAN_SIZE,   1 * MAN_SIZE,
                   0 * MAN_SIZE,  -3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   2 * MAN_SIZE,   1 * MAN_SIZE,
                   3 * MAN_SIZE,   0 * MAN_SIZE,
                   3 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -4 * MAN_SIZE,  -1 * MAN_SIZE,
                  -1 * MAN_SIZE,  -2 * MAN_SIZE
};


const signed char manLeft7[]=
{
                  24,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                   2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   2 * MAN_SIZE,
                  -2 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE,
                  -1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -2 * MAN_SIZE,   1 * MAN_SIZE,
                  -1 * MAN_SIZE,   1 * MAN_SIZE,
                  -1 * MAN_SIZE,  -3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   3 * MAN_SIZE,  -1 * MAN_SIZE,
                  -3 * MAN_SIZE,   0 * MAN_SIZE,
                  -1 * MAN_SIZE,   1 * MAN_SIZE,
                   0 * MAN_SIZE,  -3 * MAN_SIZE,
                   1 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                   3 * MAN_SIZE,   0 * MAN_SIZE,
                   3 * MAN_SIZE,   1 * MAN_SIZE,
                   3 * MAN_SIZE,   0 * MAN_SIZE,
                   0 * MAN_SIZE,   1 * MAN_SIZE,
                  -4 * MAN_SIZE,  -2 * MAN_SIZE,
                   0 * MAN_SIZE,  -1 * MAN_SIZE
};

const signed char manLeft8[]=
{
                 23,
                  0 * MAN_SIZE,  1 * MAN_SIZE,
                  2 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -2 * MAN_SIZE,
                 -2 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE,  1 * MAN_SIZE,
                 -1 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE,  1 * MAN_SIZE,
                 -5 * MAN_SIZE,  0 * MAN_SIZE,
                 -5 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -3 * MAN_SIZE,
                  1 * MAN_SIZE,  3 * MAN_SIZE,
                  2 * MAN_SIZE, -1 * MAN_SIZE,
                  2 * MAN_SIZE,  1 * MAN_SIZE,
                 -4 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE, -2 * MAN_SIZE,
                  0 * MAN_SIZE, -1 * MAN_SIZE,
                  1 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE,  1 * MAN_SIZE,
                  2 * MAN_SIZE,  0 * MAN_SIZE,
                  2 * MAN_SIZE,  0 * MAN_SIZE,
                  4 * MAN_SIZE,  0 * MAN_SIZE,
                  0 * MAN_SIZE,  1 * MAN_SIZE,
                 -4 * MAN_SIZE,  0 * MAN_SIZE,
                 -1 * MAN_SIZE, -2 * MAN_SIZE


};

const signed char * manLeft[MAN_ANIM_MAX]=
{
  manLeft8,
  manLeft7,
  manLeft6,
  manLeft5,
  manLeft4,
  manLeft3,
  manLeft2
};

const signed char **man[4]=
{
  manLeft,
  manRight,
  manLeft,
  manRight
};


#endif
