#ifndef _HELPER_I_
#define _HELPER_I_

FUNCTION_TYPE void setup(void)
{
  enable_joystick_1x();
  enable_joystick_1y();
  disable_joystick_2x();
  disable_joystick_2y();
  joy_digital();
  read_buttons();
}

FUNCTION_TYPE void start_one_vectrex_round(void)
{
  set_dp_c8();
  recalculate_music(current_song);
  wait_recal();
  do_sound();
}

FUNCTION_TYPE void play_song(unsigned char *song)
{
  write_ram(Vec_Music_Flag, 1);
  current_song = song;
}


#endif
