/* Generated automatically by the program `genrecog'
from the machine description file `md'.  */

#include "config.h"
#include <stdio.h>
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "real.h"
#include "output.h"
#include "flags.h"


/* `recog' contains a decision tree
   that recognizes whether the rtx X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.
   If the rtx is valid, recog returns a nonnegative number
   which is the insn code number for the pattern that matched.
   This is the same as the order in the machine description of
   the entry that matched.  This number can be used as an index into
   entry that matched.  This number can be used as an index into various
   insn_* tables, such as insn_templates, insn_outfun, and insn_n_operands
   (found in insn-output.c).

   The third argument to recog is an optional pointer to an int.
   If present, recog will accept a pattern if it matches except for
   missing CLOBBER expressions at the end.  In that case, the value
   pointed to by the optional pointer will be set to the number of
   CLOBBERs that need to be added (it should be initialized to zero by
   the caller).  If it is set nonzero, the caller should allocate a
   PARALLEL of the appropriate size, copy the initial entries, and call
   add_clobbers (found in insn-emit.c) to fill in the CLOBBERs.*/

rtx recog_operand[MAX_RECOG_OPERANDS];

rtx *recog_operand_loc[MAX_RECOG_OPERANDS];

rtx *recog_dup_loc[MAX_DUP_OPERANDS];

char recog_dup_num[MAX_DUP_OPERANDS];

#define operands recog_operand

int
recog_1 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4;
  int tem;

  x1 = XEXP (x0, 1);
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    default:
      break;
    case EQ:
      goto L317;
    case NE:
      goto L326;
    case GT:
      goto L335;
    case GTU:
      goto L344;
    case LT:
      goto L353;
    case LTU:
      goto L362;
    case GE:
      goto L371;
    case GEU:
      goto L380;
    case LE:
      goto L389;
    case LEU:
      goto L398;
    }
  goto ret0;

  L317:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0 && 1)
    goto L318;
  goto ret0;

  L318:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L319;
  goto ret0;

  L319:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    default:
      break;
    case LABEL_REF:
      goto L320;
    case PC:
      goto L410;
    }
  goto ret0;

  L320:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L321;

  L321:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 69;
  goto ret0;

  L410:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L411;
  goto ret0;

  L411:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  return 79;

  L326:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0 && 1)
    goto L327;
  goto ret0;

  L327:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L328;
  goto ret0;

  L328:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    default:
      break;
    case LABEL_REF:
      goto L329;
    case PC:
      goto L419;
    }
  goto ret0;

  L329:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L330;

  L330:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 70;
  goto ret0;

  L419:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L420;
  goto ret0;

  L420:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  return 80;

  L335:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0 && 1)
    goto L336;
  goto ret0;

  L336:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L337;
  goto ret0;

  L337:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    default:
      break;
    case LABEL_REF:
      goto L338;
    case PC:
      goto L428;
    }
  goto ret0;

  L338:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L339;

  L339:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 71;
  goto ret0;

  L428:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L429;
  goto ret0;

  L429:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  return 81;

  L344:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0 && 1)
    goto L345;
  goto ret0;

  L345:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L346;
  goto ret0;

  L346:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    default:
      break;
    case LABEL_REF:
      goto L347;
    case PC:
      goto L437;
    }
  goto ret0;

  L347:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L348;

  L348:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 72;
  goto ret0;

  L437:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L438;
  goto ret0;

  L438:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  return 82;

  L353:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0 && 1)
    goto L354;
  goto ret0;

  L354:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L355;
  goto ret0;

  L355:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    default:
      break;
    case LABEL_REF:
      goto L356;
    case PC:
      goto L446;
    }
  goto ret0;

  L356:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L357;

  L357:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 73;
  goto ret0;

  L446:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L447;
  goto ret0;

  L447:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  return 83;

  L362:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0 && 1)
    goto L363;
  goto ret0;

  L363:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L364;
  goto ret0;

  L364:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    default:
      break;
    case LABEL_REF:
      goto L365;
    case PC:
      goto L455;
    }
  goto ret0;

  L365:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L366;

  L366:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 74;
  goto ret0;

  L455:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L456;
  goto ret0;

  L456:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  return 84;

  L371:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0 && 1)
    goto L372;
  goto ret0;

  L372:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L373;
  goto ret0;

  L373:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    default:
      break;
    case LABEL_REF:
      goto L374;
    case PC:
      goto L464;
    }
  goto ret0;

  L374:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L375;

  L375:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 75;
  goto ret0;

  L464:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L465;
  goto ret0;

  L465:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  return 85;

  L380:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0 && 1)
    goto L381;
  goto ret0;

  L381:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L382;
  goto ret0;

  L382:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    default:
      break;
    case LABEL_REF:
      goto L383;
    case PC:
      goto L473;
    }
  goto ret0;

  L383:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L384;

  L384:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 76;
  goto ret0;

  L473:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L474;
  goto ret0;

  L474:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  return 86;

  L389:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0 && 1)
    goto L390;
  goto ret0;

  L390:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L391;
  goto ret0;

  L391:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    default:
      break;
    case LABEL_REF:
      goto L392;
    case PC:
      goto L482;
    }
  goto ret0;

  L392:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L393;

  L393:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 77;
  goto ret0;

  L482:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L483;
  goto ret0;

  L483:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  return 87;

  L398:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CC0 && 1)
    goto L399;
  goto ret0;

  L399:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L400;
  goto ret0;

  L400:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    default:
      break;
    case LABEL_REF:
      goto L401;
    case PC:
      goto L491;
    }
  goto ret0;

  L401:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L402;

  L402:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 78;
  goto ret0;

  L491:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L492;
  goto ret0;

  L492:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  return 88;
 ret0: return -1;
}

int
recog_2 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4;
  int tem;

  x1 = XEXP (x0, 0);
  switch (GET_MODE (x1))
    {
    default:
      break;
    case SImode:
      if (general_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L76;
	}
      break;
    case HImode:
      if (general_operand (x1, HImode))
	{
	  ro[0] = x1;
	  goto L97;
	}
    }
  if (GET_CODE (x1) == CC0 && 1)
    goto L2;
  L37:
  switch (GET_MODE (x1))
    {
    default:
      break;
    case QImode:
      if (byte_operand (x1, QImode))
	{
	  ro[0] = x1;
	  goto L38;
	}
    L125:
      if (register_operand (x1, QImode))
	{
	  ro[0] = x1;
	  goto L126;
	}
    L150:
      if (byte_reg_operand (x1, QImode))
	{
	  ro[0] = x1;
	  goto L151;
	}
      break;
    case SImode:
    L79:
      if (data_reg_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L80;
	}
    L100:
      if (register_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L101;
	}
      break;
    case HImode:
    L83:
      if (data_reg_operand (x1, HImode))
	{
	  ro[0] = x1;
	  goto L84;
	}
    L105:
      if (register_operand (x1, HImode))
	{
	  ro[0] = x1;
	  goto L106;
	}
    L287:
      if (byte_operand (x1, HImode))
	{
	  ro[0] = x1;
	  goto L288;
	}
    }
  L56:
  switch (GET_CODE (x1))
    {
    default:
      break;
    case STRICT_LOW_PART:
      goto L57;
    case PC:
      goto L305;
    }
  L497:
  ro[0] = x1;
  goto L498;

  L76:
  x1 = XEXP (x0, 1);
  switch (GET_MODE (x1))
    {
    default:
      break;
    case SImode:
      switch (GET_CODE (x1))
	{
	default:
	  break;
	case SIGN_EXTEND:
	  goto L77;
	case ROTATE:
	  goto L269;
	case ROTATERT:
	  goto L284;
	case SUBREG:
	case MEM:
	  if (memory_operand (x1, SImode))
	    {
	      ro[1] = x1;
	      return 7;
	    }
	}
    }
  L32:
  if (general_operand (x1, SImode))
    {
      ro[1] = x1;
      return 8;
    }
  x1 = XEXP (x0, 0);
  goto L79;

  L77:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == HImode && general_operand (x2, HImode))
    {
      ro[1] = x2;
      return 18;
    }
  x1 = XEXP (x0, 0);
  goto L79;

  L269:
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L270;
    }
  x1 = XEXP (x0, 0);
  goto L79;

  L270:
  x2 = XEXP (x1, 1);
  if (nonmemory_operand (x2, SImode))
    {
      ro[2] = x2;
      return 59;
    }
  x1 = XEXP (x0, 0);
  goto L79;

  L284:
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L285;
    }
  x1 = XEXP (x0, 0);
  goto L79;

  L285:
  x2 = XEXP (x1, 1);
  if (nonmemory_operand (x2, SImode))
    {
      ro[2] = x2;
      return 62;
    }
  x1 = XEXP (x0, 0);
  goto L79;

  L97:
  x1 = XEXP (x0, 1);
  switch (GET_MODE (x1))
    {
    default:
      break;
    case HImode:
      switch (GET_CODE (x1))
	{
	default:
	  break;
	case ZERO_EXTEND:
	  goto L98;
	case NEG:
	  goto L191;
	case NOT:
	  goto L203;
	case ROTATE:
	  goto L274;
	}
    }
  if (general_operand (x1, HImode))
    {
      ro[1] = x1;
      return 9;
    }
  x1 = XEXP (x0, 0);
  goto L83;

  L98:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == QImode && general_operand (x2, QImode))
    {
      ro[1] = x2;
      return 22;
    }
  x1 = XEXP (x0, 0);
  goto L83;

  L191:
  x2 = XEXP (x1, 0);
  if (general_operand (x2, HImode))
    {
      ro[1] = x2;
      return 46;
    }
  x1 = XEXP (x0, 0);
  goto L83;

  L203:
  x2 = XEXP (x1, 0);
  if (general_operand (x2, HImode))
    {
      ro[1] = x2;
      return 49;
    }
  x1 = XEXP (x0, 0);
  goto L83;

  L274:
  x2 = XEXP (x1, 0);
  if (general_operand (x2, HImode))
    {
      ro[1] = x2;
      goto L275;
    }
  x1 = XEXP (x0, 0);
  goto L83;

  L275:
  x2 = XEXP (x1, 1);
  if (nonmemory_operand (x2, HImode))
    {
      ro[2] = x2;
      return 60;
    }
  x1 = XEXP (x0, 0);
  goto L83;

  L2:
  x1 = XEXP (x0, 1);
  switch (GET_MODE (x1))
    {
    default:
      break;
    case SImode:
      if (register_operand (x1, SImode))
	{
	  ro[0] = x1;
	  return 0;
	}
      break;
    case HImode:
      if (register_operand (x1, HImode))
	{
	  ro[0] = x1;
	  return 1;
	}
    }
  L8:
  if (byte_operand (x1, QImode))
    {
      ro[0] = x1;
      return 2;
    }
  L11:
  if (memory_operand (x1, SImode))
    {
      ro[0] = x1;
      return 3;
    }
  if (GET_CODE (x1) == COMPARE && 1)
    goto L15;
  x1 = XEXP (x0, 0);
  goto L37;

  L15:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    default:
      break;
    case SImode:
      if (general_operand (x2, SImode))
	{
	  ro[0] = x2;
	  goto L16;
	}
      break;
    case HImode:
      if (general_operand (x2, HImode))
	{
	  ro[0] = x2;
	  goto L21;
	}
      break;
    case QImode:
      if (byte_operand (x2, QImode))
	{
	  ro[0] = x2;
	  goto L26;
	}
    }
  x1 = XEXP (x0, 0);
  goto L37;

  L16:
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SImode))
    {
      ro[1] = x2;
      return 4;
    }
  x1 = XEXP (x0, 0);
  goto L37;

  L21:
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      ro[1] = x2;
      return 5;
    }
  x1 = XEXP (x0, 0);
  goto L37;

  L26:
  x2 = XEXP (x1, 1);
  if (byte_operand (x2, QImode))
    {
      ro[1] = x2;
      return 6;
    }
  x1 = XEXP (x0, 0);
  goto L37;

  L38:
  x1 = XEXP (x0, 1);
  if (byte_operand (x1, QImode))
    {
      ro[1] = x1;
      return 10;
    }
  L41:
  if (GET_MODE (x1) != QImode)
    {
      x1 = XEXP (x0, 0);
      goto L125;
    }
  switch (GET_CODE (x1))
    {
    default:
      break;
    case SUBREG:
      if (XINT (x1, 1) == 1 && 1)
	goto L42;
      if (XINT (x1, 1) == 0 && 1)
	goto L46;
      break;
    case PLUS:
      goto L112;
    case NEG:
      goto L195;
    case NOT:
      goto L207;
    case ASHIFTRT:
      goto L248;
    case ROTATE:
      goto L279;
    case ROTATERT:
      goto L294;
    }
  x1 = XEXP (x0, 0);
  goto L125;

  L42:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && general_operand (x2, SImode))
    {
      ro[1] = x2;
      return 11;
    }
  x1 = XEXP (x0, 0);
  goto L125;

  L46:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    default:
      break;
    case SImode:
      if (general_operand (x2, SImode))
	{
	  ro[1] = x2;
	  return 12;
	}
      break;
    case HImode:
      if (general_operand (x2, HImode))
	{
	  ro[1] = x2;
	  return 13;
	}
      break;
    case QImode:
      if (byte_operand (x2, QImode))
	{
	  ro[1] = x2;
	  return 14;
	}
    }
  x1 = XEXP (x0, 0);
  goto L125;

  L112:
  x2 = XEXP (x1, 0);
  if (byte_operand (x2, QImode))
    {
      ro[1] = x2;
      goto L113;
    }
  x1 = XEXP (x0, 0);
  goto L125;

  L113:
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      ro[2] = x2;
      return 25;
    }
  x1 = XEXP (x0, 0);
  goto L125;

  L195:
  x2 = XEXP (x1, 0);
  if (byte_operand (x2, QImode))
    {
      ro[1] = x2;
      return 47;
    }
  x1 = XEXP (x0, 0);
  goto L125;

  L207:
  x2 = XEXP (x1, 0);
  if (byte_operand (x2, QImode))
    {
      ro[1] = x2;
      return 50;
    }
  x1 = XEXP (x0, 0);
  goto L125;

  L248:
  x2 = XEXP (x1, 0);
  if (general_operand (x2, QImode))
    {
      ro[1] = x2;
      goto L249;
    }
  x1 = XEXP (x0, 0);
  goto L125;

  L249:
  x2 = XEXP (x1, 1);
  if (nonmemory_operand (x2, QImode))
    {
      ro[2] = x2;
      return 56;
    }
  x1 = XEXP (x0, 0);
  goto L125;

  L279:
  x2 = XEXP (x1, 0);
  if (byte_operand (x2, QImode))
    {
      ro[1] = x2;
      goto L280;
    }
  x1 = XEXP (x0, 0);
  goto L125;

  L280:
  x2 = XEXP (x1, 1);
  if (nonmemory_operand (x2, HImode))
    {
      ro[2] = x2;
      return 61;
    }
  x1 = XEXP (x0, 0);
  goto L125;

  L294:
  x2 = XEXP (x1, 0);
  if (byte_operand (x2, QImode))
    {
      ro[1] = x2;
      goto L295;
    }
  x1 = XEXP (x0, 0);
  goto L125;

  L295:
  x2 = XEXP (x1, 1);
  if (nonmemory_operand (x2, QImode))
    {
      ro[2] = x2;
      return 64;
    }
  x1 = XEXP (x0, 0);
  goto L125;

  L126:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != QImode)
    {
      x1 = XEXP (x0, 0);
      goto L150;
    }
  switch (GET_CODE (x1))
    {
    default:
      break;
    case MINUS:
      goto L127;
    case MULT:
      goto L137;
    }
  x1 = XEXP (x0, 0);
  goto L150;

  L127:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, QImode))
    {
      ro[1] = x2;
      goto L128;
    }
  x1 = XEXP (x0, 0);
  goto L150;

  L128:
  x2 = XEXP (x1, 1);
  if (address_operand (x2, QImode))
    {
      ro[2] = x2;
      return 29;
    }
  x1 = XEXP (x0, 0);
  goto L150;

  L137:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, QImode))
    {
      ro[1] = x2;
      goto L138;
    }
  x1 = XEXP (x0, 0);
  goto L150;

  L138:
  x2 = XEXP (x1, 1);
  if (byte_operand (x2, QImode))
    {
      ro[2] = x2;
      return 31;
    }
  x1 = XEXP (x0, 0);
  goto L150;

  L151:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != QImode)
    {
      x1 = XEXP (x0, 0);
      goto L56;
    }
  switch (GET_CODE (x1))
    {
    default:
      break;
    case AND:
      goto L152;
    case IOR:
      goto L167;
    case XOR:
      goto L182;
    case ASHIFT:
      goto L227;
    }
  x1 = XEXP (x0, 0);
  goto L56;

  L152:
  x2 = XEXP (x1, 0);
  if (byte_reg_operand (x2, QImode))
    {
      ro[1] = x2;
      goto L153;
    }
  x1 = XEXP (x0, 0);
  goto L56;

  L153:
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      ro[2] = x2;
      return 38;
    }
  x1 = XEXP (x0, 0);
  goto L56;

  L167:
  x2 = XEXP (x1, 0);
  if (byte_reg_operand (x2, QImode))
    {
      ro[1] = x2;
      goto L168;
    }
  x1 = XEXP (x0, 0);
  goto L56;

  L168:
  x2 = XEXP (x1, 1);
  if (general_operand (x2, QImode))
    {
      ro[2] = x2;
      return 41;
    }
  x1 = XEXP (x0, 0);
  goto L56;

  L182:
  x2 = XEXP (x1, 0);
  if (byte_reg_operand (x2, QImode))
    {
      ro[1] = x2;
      goto L183;
    }
  x1 = XEXP (x0, 0);
  goto L56;

  L183:
  x2 = XEXP (x1, 1);
  if (byte_operand (x2, QImode))
    {
      ro[2] = x2;
      return 44;
    }
  x1 = XEXP (x0, 0);
  goto L56;

  L227:
  x2 = XEXP (x1, 0);
  if (byte_reg_operand (x2, QImode))
    {
      ro[1] = x2;
      goto L228;
    }
  x1 = XEXP (x0, 0);
  goto L56;

  L228:
  x2 = XEXP (x1, 1);
  if (nonmemory_operand (x2, QImode))
    {
      ro[2] = x2;
      return 53;
    }
  x1 = XEXP (x0, 0);
  goto L56;

  L80:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != SImode)
    {
      x1 = XEXP (x0, 0);
      goto L100;
    }
  switch (GET_CODE (x1))
    {
    default:
      break;
    case SIGN_EXTEND:
      goto L81;
    case AND:
      goto L142;
    case IOR:
      goto L157;
    case XOR:
      goto L172;
    case NOT:
      goto L199;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L81:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == QImode && byte_operand (x2, QImode))
    {
      ro[1] = x2;
      return 19;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L142:
  x2 = XEXP (x1, 0);
  if (data_reg_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L143;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L143:
  x2 = XEXP (x1, 1);
  if (address_operand (x2, SImode))
    {
      ro[2] = x2;
      return 36;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L157:
  x2 = XEXP (x1, 0);
  if (data_reg_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L158;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L158:
  x2 = XEXP (x1, 1);
  if (address_operand (x2, SImode))
    {
      ro[2] = x2;
      return 39;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L172:
  x2 = XEXP (x1, 0);
  if (data_reg_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L173;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L173:
  x2 = XEXP (x1, 1);
  if (address_operand (x2, SImode))
    {
      ro[2] = x2;
      return 42;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L199:
  x2 = XEXP (x1, 0);
  if (data_reg_operand (x2, SImode))
    {
      ro[1] = x2;
      return 48;
    }
  x1 = XEXP (x0, 0);
  goto L100;

  L101:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != SImode)
    {
      x1 = XEXP (x0, 0);
      goto L497;
    }
  switch (GET_CODE (x1))
    {
    default:
      break;
    case PLUS:
      goto L102;
    case MINUS:
      goto L117;
    case NEG:
      goto L187;
    }
  x1 = XEXP (x0, 0);
  goto L497;

  L102:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L103;
    }
  x1 = XEXP (x0, 0);
  goto L497;

  L103:
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SImode))
    {
      ro[2] = x2;
      return 23;
    }
  x1 = XEXP (x0, 0);
  goto L497;

  L117:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L118;
    }
  x1 = XEXP (x0, 0);
  goto L497;

  L118:
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SImode))
    {
      ro[2] = x2;
      return 26;
    }
  x1 = XEXP (x0, 0);
  goto L497;

  L187:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      return 45;
    }
  x1 = XEXP (x0, 0);
  goto L497;

  L84:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != HImode)
    {
      x1 = XEXP (x0, 0);
      goto L105;
    }
  switch (GET_CODE (x1))
    {
    default:
      break;
    case SIGN_EXTEND:
      goto L85;
    case AND:
      goto L147;
    case IOR:
      goto L162;
    case XOR:
      goto L177;
    }
  x1 = XEXP (x0, 0);
  goto L105;

  L85:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == QImode && byte_operand (x2, QImode))
    {
      ro[1] = x2;
      return 20;
    }
  x1 = XEXP (x0, 0);
  goto L105;

  L147:
  x2 = XEXP (x1, 0);
  if (data_reg_operand (x2, HImode))
    {
      ro[1] = x2;
      goto L148;
    }
  x1 = XEXP (x0, 0);
  goto L105;

  L148:
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      ro[2] = x2;
      return 37;
    }
  x1 = XEXP (x0, 0);
  goto L105;

  L162:
  x2 = XEXP (x1, 0);
  if (data_reg_operand (x2, HImode))
    {
      ro[1] = x2;
      goto L163;
    }
  x1 = XEXP (x0, 0);
  goto L105;

  L163:
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      ro[2] = x2;
      return 40;
    }
  x1 = XEXP (x0, 0);
  goto L105;

  L177:
  x2 = XEXP (x1, 0);
  if (data_reg_operand (x2, HImode))
    {
      ro[1] = x2;
      goto L178;
    }
  x1 = XEXP (x0, 0);
  goto L105;

  L178:
  x2 = XEXP (x1, 1);
  if (address_operand (x2, HImode))
    {
      ro[2] = x2;
      return 43;
    }
  x1 = XEXP (x0, 0);
  goto L105;

  L106:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != HImode)
    {
      x1 = XEXP (x0, 0);
      goto L287;
    }
  switch (GET_CODE (x1))
    {
    default:
      break;
    case PLUS:
      goto L107;
    case MINUS:
      goto L122;
    case MULT:
      goto L132;
    }
  x1 = XEXP (x0, 0);
  goto L287;

  L107:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, HImode))
    {
      ro[1] = x2;
      goto L108;
    }
  x1 = XEXP (x0, 0);
  goto L287;

  L108:
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      ro[2] = x2;
      return 24;
    }
  x1 = XEXP (x0, 0);
  goto L287;

  L122:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, HImode))
    {
      ro[1] = x2;
      goto L123;
    }
  x1 = XEXP (x0, 0);
  goto L287;

  L123:
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      ro[2] = x2;
      return 28;
    }
  x1 = XEXP (x0, 0);
  goto L287;

  L132:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, HImode))
    {
      ro[1] = x2;
      goto L133;
    }
  x1 = XEXP (x0, 0);
  goto L287;

  L133:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, HImode))
    {
      ro[2] = x2;
      return 30;
    }
  x1 = XEXP (x0, 0);
  goto L287;

  L288:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == HImode && GET_CODE (x1) == ROTATERT && 1)
    goto L289;
  x1 = XEXP (x0, 0);
  goto L56;

  L289:
  x2 = XEXP (x1, 0);
  if (byte_operand (x2, HImode))
    {
      ro[1] = x2;
      goto L290;
    }
  x1 = XEXP (x0, 0);
  goto L56;

  L290:
  x2 = XEXP (x1, 1);
  if (nonmemory_operand (x2, HImode))
    {
      ro[2] = x2;
      return 63;
    }
  x1 = XEXP (x0, 0);
  goto L56;

  L57:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == HImode && GET_CODE (x2) == SUBREG && XINT (x2, 1) == 0 && 1)
    goto L58;
  goto L497;

  L58:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && general_operand (x3, SImode))
    {
      ro[0] = x3;
      goto L59;
    }
  goto L497;

  L59:
  x1 = XEXP (x0, 1);
  if (byte_operand (x1, HImode))
    {
      ro[1] = x1;
      return 15;
    }
  x1 = XEXP (x0, 0);
  goto L497;

  L305:
  x1 = XEXP (x0, 1);
  if (address_operand (x1, SImode))
    {
      ro[0] = x1;
      return 66;
    }
  L308:
  if (address_operand (x1, HImode))
    {
      ro[0] = x1;
      return 67;
    }
  L311:
  switch (GET_CODE (x1))
    {
    default:
      break;
    case LABEL_REF:
      goto L312;
    case IF_THEN_ELSE:
      goto L316;
    }
  x1 = XEXP (x0, 0);
  goto L497;

  L312:
  x2 = XEXP (x1, 0);
  ro[0] = x2;
  return 68;
 L316:
  tem = recog_1 (x0, insn, pnum_clobbers);
  if (tem >= 0) return tem;
  x1 = XEXP (x0, 0);
  goto L497;

  L498:
  x1 = XEXP (x0, 1);
  if (GET_CODE (x1) == CALL && 1)
    goto L499;
  goto ret0;

  L499:
  x2 = XEXP (x1, 0);
  if (general_operand (x2, HImode))
    {
      ro[1] = x2;
      goto L500;
    }
  goto ret0;

  L500:
  x2 = XEXP (x1, 1);
  if (general_operand (x2, SImode))
    {
      ro[2] = x2;
      return 90;
    }
  goto ret0;
 ret0: return -1;
}

int
recog_3 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4;
  int tem;

  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    default:
      break;
    case SImode:
      if (register_operand (x2, SImode))
	{
	  ro[0] = x2;
	  goto L63;
	}
    L88:
      if (general_operand (x2, SImode))
	{
	  ro[0] = x2;
	  goto L211;
	}
      break;
    case QImode:
      if (byte_reg_operand (x2, QImode))
	{
	  ro[0] = x2;
	  goto L70;
	}
      break;
    case HImode:
      if (general_operand (x2, HImode))
	{
	  ro[0] = x2;
	  goto L219;
	}
    }
  L298:
  if (GET_CODE (x2) == PC && 1)
    goto L299;
  goto ret0;

  L63:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L64;
    }
  x2 = XEXP (x1, 0);
  goto L88;

  L64:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L65;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L88;

  L65:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[1]) && 1)
    goto L66;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L88;

  L66:
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, ro[0]) && 1)
    return 16;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L88;

  L211:
  x2 = XEXP (x1, 1);
  switch (GET_MODE (x2))
    {
    default:
      break;
    case SImode:
      switch (GET_CODE (x2))
	{
	default:
	  break;
	case ASHIFT:
	  goto L212;
	case ASHIFTRT:
	  goto L233;
	case LSHIFTRT:
	  goto L254;
	}
    }
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    goto L90;
  goto ret0;

  L212:
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L213;
    }
  goto ret0;

  L213:
  x3 = XEXP (x2, 1);
  if (nonmemory_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L214;
    }
  goto ret0;

  L214:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L215;
  goto ret0;

  L215:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[2]) && 1)
    return 51;
  goto ret0;

  L233:
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L234;
    }
  goto ret0;

  L234:
  x3 = XEXP (x2, 1);
  if (nonmemory_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L235;
    }
  goto ret0;

  L235:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L236;
  goto ret0;

  L236:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[2]) && 1)
    return 54;
  goto ret0;

  L254:
  x3 = XEXP (x2, 0);
  if (general_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L255;
    }
  goto ret0;

  L255:
  x3 = XEXP (x2, 1);
  if (nonmemory_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L256;
    }
  goto ret0;

  L256:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L257;
  goto ret0;

  L257:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[2]) && 1)
    return 57;
  goto ret0;

  L90:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L91;
  goto ret0;

  L91:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == STRICT_LOW_PART && 1)
    goto L92;
  goto ret0;

  L92:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == HImode && GET_CODE (x3) == SUBREG && XINT (x3, 1) == 0 && 1)
    goto L93;
  goto ret0;

  L93:
  x4 = XEXP (x3, 0);
  if (rtx_equal_p (x4, ro[0]) && 1)
    goto L94;
  goto ret0;

  L94:
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      ro[1] = x2;
      return 21;
    }
  goto ret0;

  L70:
  x2 = XEXP (x1, 1);
  if (byte_reg_operand (x2, QImode))
    {
      ro[1] = x2;
      goto L71;
    }
  x2 = XEXP (x1, 0);
  goto L298;

  L71:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L72;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L298;

  L72:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[1]) && 1)
    goto L73;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L298;

  L73:
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, ro[0]) && 1)
    return 17;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L298;

  L219:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != HImode)
    goto ret0;
  switch (GET_CODE (x2))
    {
    default:
      break;
    case ASHIFT:
      goto L220;
    case ASHIFTRT:
      goto L241;
    case LSHIFTRT:
      goto L262;
    }
  goto ret0;

  L220:
  x3 = XEXP (x2, 0);
  if (general_operand (x3, HImode))
    {
      ro[1] = x3;
      goto L221;
    }
  goto ret0;

  L221:
  x3 = XEXP (x2, 1);
  if (nonmemory_operand (x3, HImode))
    {
      ro[2] = x3;
      goto L222;
    }
  goto ret0;

  L222:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L223;
  goto ret0;

  L223:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[2]) && 1)
    return 52;
  goto ret0;

  L241:
  x3 = XEXP (x2, 0);
  if (general_operand (x3, HImode))
    {
      ro[1] = x3;
      goto L242;
    }
  goto ret0;

  L242:
  x3 = XEXP (x2, 1);
  if (nonmemory_operand (x3, HImode))
    {
      ro[2] = x3;
      goto L243;
    }
  goto ret0;

  L243:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L244;
  goto ret0;

  L244:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[2]) && 1)
    return 55;
  goto ret0;

  L262:
  x3 = XEXP (x2, 0);
  if (general_operand (x3, HImode))
    {
      ro[1] = x3;
      goto L263;
    }
  goto ret0;

  L263:
  x3 = XEXP (x2, 1);
  if (nonmemory_operand (x3, HImode))
    {
      ro[2] = x3;
      goto L264;
    }
  goto ret0;

  L264:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L265;
  goto ret0;

  L265:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[2]) && 1)
    return 58;
  goto ret0;

  L299:
  x2 = XEXP (x1, 1);
  if (general_operand (x2, HImode))
    {
      ro[0] = x2;
      goto L300;
    }
  goto ret0;

  L300:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L301;
  goto ret0;

  L301:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L302;
  goto ret0;

  L302:
  x3 = XEXP (x2, 0);
  ro[1] = x3;
  return 65;
 ret0: return -1;
}

int
recog (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4;
  int tem;

  L0:
  switch (GET_CODE (x0))
    {
    default:
      break;
    case SET:
      goto L28;
    case PARALLEL:
      if (XVECLEN (x0, 0) == 2 && 1)
	goto L61;
      break;
    case CALL:
      goto L494;
    case CONST_INT:
      if (XWINT (x0, 0) == 0 && 1)
	return 94;
    }
  goto ret0;
 L28:
  return recog_2 (x0, insn, pnum_clobbers);

  L61:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == SET && 1)
    goto L62;
  goto ret0;
 L62:
  return recog_3 (x0, insn, pnum_clobbers);

  L494:
  x1 = XEXP (x0, 0);
  if (general_operand (x1, HImode))
    {
      ro[0] = x1;
      goto L495;
    }
  goto ret0;

  L495:
  x1 = XEXP (x0, 1);
  if (general_operand (x1, SImode))
    {
      ro[1] = x1;
      return 89;
    }
  goto ret0;
 ret0: return -1;
}

rtx
split_insns (x0, insn)
     register rtx x0;
     rtx insn;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4;
  rtx tem;

  goto ret0;
 ret0: return 0;
}

